# uchar.h File Reference

C API: Unicode Properties. More...

`#include "unicode/utypes.h"`

Go to the source code of this file.

## Defines
#define | U_UNICODE_VERSION "5.2"
| Unicode version number, default for the current ICU version.
#define | UCHAR_MIN_VALUE 0
| Constants.
#define | UCHAR_MAX_VALUE 0x10ffff
| The highest Unicode code point value (scalar value) according to The Unicode Standard.
#define | U_MASK(x) ((uint32_t)1<<(x))
| Get a single-bit bit set (a flag) from a bit number 0..31.
#define | U_GC_CN_MASK U_MASK(U_GENERAL_OTHER_TYPES)
| U_GC_XX_MASK constants are bit flags corresponding to Unicode general category values.
#define | U_GC_LU_MASK U_MASK(U_UPPERCASE_LETTER)
| Mask constant for a UCharCategory.
#define | U_GC_LL_MASK U_MASK(U_LOWERCASE_LETTER)
| Mask constant for a UCharCategory.
#define | U_GC_LT_MASK U_MASK(U_TITLECASE_LETTER)
| Mask constant for a UCharCategory.
#define | U_GC_LM_MASK U_MASK(U_MODIFIER_LETTER)
| Mask constant for a UCharCategory.
#define | U_GC_LO_MASK U_MASK(U_OTHER_LETTER)
| Mask constant for a UCharCategory.
#define | U_GC_MN_MASK U_MASK(U_NON_SPACING_MARK)
| Mask constant for a UCharCategory.
#define | U_GC_ME_MASK U_MASK(U_ENCLOSING_MARK)
| Mask constant for a UCharCategory.
#define | U_GC_MC_MASK U_MASK(U_COMBINING_SPACING_MARK)
| Mask constant for a UCharCategory.
#define | U_GC_ND_MASK U_MASK(U_DECIMAL_DIGIT_NUMBER)
| Mask constant for a UCharCategory.
#define | U_GC_NL_MASK U_MASK(U_LETTER_NUMBER)
| Mask constant for a UCharCategory.
#define | U_GC_NO_MASK U_MASK(U_OTHER_NUMBER)
| Mask constant for a UCharCategory.
#define | U_GC_ZS_MASK U_MASK(U_SPACE_SEPARATOR)
| Mask constant for a UCharCategory.
#define | U_GC_ZL_MASK U_MASK(U_LINE_SEPARATOR)
| Mask constant for a UCharCategory.
#define | U_GC_ZP_MASK U_MASK(U_PARAGRAPH_SEPARATOR)
| Mask constant for a UCharCategory.
#define | U_GC_CC_MASK U_MASK(U_CONTROL_CHAR)
| Mask constant for a UCharCategory.
#define | U_GC_CF_MASK U_MASK(U_FORMAT_CHAR)
| Mask constant for a UCharCategory.
#define | U_GC_CO_MASK U_MASK(U_PRIVATE_USE_CHAR)
| Mask constant for a UCharCategory.
#define | U_GC_CS_MASK U_MASK(U_SURROGATE)
| Mask constant for a UCharCategory.
#define | U_GC_PD_MASK U_MASK(U_DASH_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_PS_MASK U_MASK(U_START_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_PE_MASK U_MASK(U_END_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_PC_MASK U_MASK(U_CONNECTOR_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_PO_MASK U_MASK(U_OTHER_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_SM_MASK U_MASK(U_MATH_SYMBOL)
| Mask constant for a UCharCategory.
#define | U_GC_SC_MASK U_MASK(U_CURRENCY_SYMBOL)
| Mask constant for a UCharCategory.
#define | U_GC_SK_MASK U_MASK(U_MODIFIER_SYMBOL)
| Mask constant for a UCharCategory.
#define | U_GC_SO_MASK U_MASK(U_OTHER_SYMBOL)
| Mask constant for a UCharCategory.
#define | U_GC_PI_MASK U_MASK(U_INITIAL_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_PF_MASK U_MASK(U_FINAL_PUNCTUATION)
| Mask constant for a UCharCategory.
#define | U_GC_L_MASK (U_GC_LU_MASK|U_GC_LL_MASK|U_GC_LT_MASK|U_GC_LM_MASK|U_GC_LO_MASK)
| Mask constant for multiple UCharCategory bits (L Letters).
#define | U_GC_LC_MASK (U_GC_LU_MASK|U_GC_LL_MASK|U_GC_LT_MASK)
| Mask constant for multiple UCharCategory bits (LC Cased Letters).
#define | U_GC_M_MASK (U_GC_MN_MASK|U_GC_ME_MASK|U_GC_MC_MASK)
| Mask constant for multiple UCharCategory bits (M Marks).
#define | U_GC_N_MASK (U_GC_ND_MASK|U_GC_NL_MASK|U_GC_NO_MASK)
| Mask constant for multiple UCharCategory bits (N Numbers).
#define | U_GC_Z_MASK (U_GC_ZS_MASK|U_GC_ZL_MASK|U_GC_ZP_MASK)
| Mask constant for multiple UCharCategory bits (Z Separators).
#define | U_GC_C_MASK (U_GC_CN_MASK|U_GC_CC_MASK|U_GC_CF_MASK|U_GC_CO_MASK|U_GC_CS_MASK)
| Mask constant for multiple UCharCategory bits (C Others).
#define | U_GC_P_MASK
| Mask constant for multiple UCharCategory bits (P Punctuation).
#define | U_GC_S_MASK (U_GC_SM_MASK|U_GC_SC_MASK|U_GC_SK_MASK|U_GC_SO_MASK)
| Mask constant for multiple UCharCategory bits (S Symbols).
#define | U_NO_NUMERIC_VALUE ((double)-123456789.)
| Special value that is returned by u_getNumericValue when no numeric value is defined for a code point.
#define | U_GET_GC_MASK(c) U_MASK(u_charType(c))
| Get a single-bit bit set for the general category of a character.
#define | U_FOLD_CASE_DEFAULT 0
| Option value for case folding: use default mappings defined in CaseFolding.txt.
#define | U_FOLD_CASE_EXCLUDE_SPECIAL_I 1
| Option value for case folding:.
## Typedefs
typedef enum UBlockCode | UBlockCode
typedef UBool | UCharEnumTypeRange (const void *context, UChar32 start, UChar32 limit, UCharCategory type)
| Callback from u_enumCharTypes(), is called for each contiguous range of code points c (where start<=c<limit) with the same Unicode general category ("character type").
typedef UBool | UEnumCharNamesFn (void *context, UChar32 code, UCharNameChoice nameChoice, const char *name, int32_t length)
| Type of a callback function for u_enumCharNames() that gets called for each Unicode character with the code point value and the character name.
## Enumerations
enum | UProperty { UCHAR_ALPHABETIC = 0, UCHAR_BINARY_START = UCHAR_ALPHABETIC, UCHAR_ASCII_HEX_DIGIT = 1, UCHAR_BIDI_CONTROL = 2, UCHAR_BIDI_MIRRORED = 3, UCHAR_DASH = 4, UCHAR_DEFAULT_IGNORABLE_CODE_POINT = 5, UCHAR_DEPRECATED = 6, UCHAR_DIACRITIC = 7, UCHAR_EXTENDER = 8, UCHAR_FULL_COMPOSITION_EXCLUSION = 9, UCHAR_GRAPHEME_BASE = 10, UCHAR_GRAPHEME_EXTEND = 11, UCHAR_GRAPHEME_LINK = 12, UCHAR_HEX_DIGIT = 13, UCHAR_HYPHEN = 14, UCHAR_ID_CONTINUE = 15, UCHAR_ID_START = 16, UCHAR_IDEOGRAPHIC = 17, UCHAR_IDS_BINARY_OPERATOR = 18, UCHAR_IDS_TRINARY_OPERATOR = 19, UCHAR_JOIN_CONTROL = 20, UCHAR_LOGICAL_ORDER_EXCEPTION = 21, UCHAR_LOWERCASE = 22, UCHAR_MATH = 23, UCHAR_NONCHARACTER_CODE_POINT = 24, UCHAR_QUOTATION_MARK = 25, UCHAR_RADICAL = 26, UCHAR_SOFT_DOTTED = 27, UCHAR_TERMINAL_PUNCTUATION = 28, UCHAR_UNIFIED_IDEOGRAPH = 29, UCHAR_UPPERCASE = 30, UCHAR_WHITE_SPACE = 31, UCHAR_XID_CONTINUE = 32, UCHAR_XID_START = 33, UCHAR_CASE_SENSITIVE = 34, UCHAR_S_TERM = 35, UCHAR_VARIATION_SELECTOR = 36, UCHAR_NFD_INERT = 37, UCHAR_NFKD_INERT = 38, UCHAR_NFC_INERT = 39, UCHAR_NFKC_INERT = 40, UCHAR_SEGMENT_STARTER = 41, UCHAR_PATTERN_SYNTAX = 42, UCHAR_PATTERN_WHITE_SPACE = 43, UCHAR_POSIX_ALNUM = 44, UCHAR_POSIX_BLANK = 45, UCHAR_POSIX_GRAPH = 46, UCHAR_POSIX_PRINT = 47, UCHAR_POSIX_XDIGIT = 48, UCHAR_CASED = 49, UCHAR_CASE_IGNORABLE = 50, UCHAR_CHANGES_WHEN_LOWERCASED = 51, UCHAR_CHANGES_WHEN_UPPERCASED = 52, UCHAR_CHANGES_WHEN_TITLECASED = 53, UCHAR_CHANGES_WHEN_CASEFOLDED = 54, UCHAR_CHANGES_WHEN_CASEMAPPED = 55, UCHAR_CHANGES_WHEN_NFKC_CASEFOLDED = 56, UCHAR_BINARY_LIMIT = 57, UCHAR_BIDI_CLASS = 0x1000, UCHAR_INT_START = UCHAR_BIDI_CLASS, UCHAR_BLOCK = 0x1001, UCHAR_CANONICAL_COMBINING_CLASS = 0x1002, UCHAR_DECOMPOSITION_TYPE = 0x1003, UCHAR_EAST_ASIAN_WIDTH = 0x1004, UCHAR_GENERAL_CATEGORY = 0x1005, UCHAR_JOINING_GROUP = 0x1006, UCHAR_JOINING_TYPE = 0x1007, UCHAR_LINE_BREAK = 0x1008, UCHAR_NUMERIC_TYPE = 0x1009, UCHAR_SCRIPT = 0x100A, UCHAR_HANGUL_SYLLABLE_TYPE = 0x100B, UCHAR_NFD_QUICK_CHECK = 0x100C, UCHAR_NFKD_QUICK_CHECK = 0x100D, UCHAR_NFC_QUICK_CHECK = 0x100E, UCHAR_NFKC_QUICK_CHECK = 0x100F, UCHAR_LEAD_CANONICAL_COMBINING_CLASS = 0x1010, UCHAR_TRAIL_CANONICAL_COMBINING_CLASS = 0x1011, UCHAR_GRAPHEME_CLUSTER_BREAK = 0x1012, UCHAR_SENTENCE_BREAK = 0x1013, UCHAR_WORD_BREAK = 0x1014, UCHAR_INT_LIMIT = 0x1015, UCHAR_GENERAL_CATEGORY_MASK = 0x2000, UCHAR_MASK_START = UCHAR_GENERAL_CATEGORY_MASK, UCHAR_MASK_LIMIT = 0x2001, UCHAR_NUMERIC_VALUE = 0x3000, UCHAR_DOUBLE_START = UCHAR_NUMERIC_VALUE, UCHAR_DOUBLE_LIMIT = 0x3001, UCHAR_AGE = 0x4000, UCHAR_STRING_START = UCHAR_AGE, UCHAR_BIDI_MIRRORING_GLYPH = 0x4001, UCHAR_CASE_FOLDING = 0x4002, UCHAR_ISO_COMMENT = 0x4003, UCHAR_LOWERCASE_MAPPING = 0x4004, UCHAR_NAME = 0x4005, UCHAR_SIMPLE_CASE_FOLDING = 0x4006, UCHAR_SIMPLE_LOWERCASE_MAPPING = 0x4007, UCHAR_SIMPLE_TITLECASE_MAPPING = 0x4008, UCHAR_SIMPLE_UPPERCASE_MAPPING = 0x4009, UCHAR_TITLECASE_MAPPING = 0x400A, UCHAR_UNICODE_1_NAME = 0x400B, UCHAR_UPPERCASE_MAPPING = 0x400C, UCHAR_STRING_LIMIT = 0x400D, UCHAR_INVALID_CODE = -1 }
| Selection constants for Unicode properties. More...
enum | UCharCategory { U_UNASSIGNED = 0, U_GENERAL_OTHER_TYPES = 0, U_UPPERCASE_LETTER = 1, U_LOWERCASE_LETTER = 2, U_TITLECASE_LETTER = 3, U_MODIFIER_LETTER = 4, U_OTHER_LETTER = 5, U_NON_SPACING_MARK = 6, U_ENCLOSING_MARK = 7, U_COMBINING_SPACING_MARK = 8, U_DECIMAL_DIGIT_NUMBER = 9, U_LETTER_NUMBER = 10, U_OTHER_NUMBER = 11, U_SPACE_SEPARATOR = 12, U_LINE_SEPARATOR = 13, U_PARAGRAPH_SEPARATOR = 14, U_CONTROL_CHAR = 15, U_FORMAT_CHAR = 16, U_PRIVATE_USE_CHAR = 17, U_SURROGATE = 18, U_DASH_PUNCTUATION = 19, U_START_PUNCTUATION = 20, U_END_PUNCTUATION = 21, U_CONNECTOR_PUNCTUATION = 22, U_OTHER_PUNCTUATION = 23, U_MATH_SYMBOL = 24, U_CURRENCY_SYMBOL = 25, U_MODIFIER_SYMBOL = 26, U_OTHER_SYMBOL = 27, U_INITIAL_PUNCTUATION = 28, U_FINAL_PUNCTUATION = 29, U_CHAR_CATEGORY_COUNT }
| Data for enumerated Unicode general category types. More...
enum | UCharDirection { U_LEFT_TO_RIGHT = 0, U_RIGHT_TO_LEFT = 1, U_EUROPEAN_NUMBER = 2, U_EUROPEAN_NUMBER_SEPARATOR = 3, U_EUROPEAN_NUMBER_TERMINATOR = 4, U_ARABIC_NUMBER = 5, U_COMMON_NUMBER_SEPARATOR = 6, U_BLOCK_SEPARATOR = 7, U_SEGMENT_SEPARATOR = 8, U_WHITE_SPACE_NEUTRAL = 9, U_OTHER_NEUTRAL = 10, U_LEFT_TO_RIGHT_EMBEDDING = 11, U_LEFT_TO_RIGHT_OVERRIDE = 12, U_RIGHT_TO_LEFT_ARABIC = 13, U_RIGHT_TO_LEFT_EMBEDDING = 14, U_RIGHT_TO_LEFT_OVERRIDE = 15, U_POP_DIRECTIONAL_FORMAT = 16, U_DIR_NON_SPACING_MARK = 17, U_BOUNDARY_NEUTRAL = 18, U_CHAR_DIRECTION_COUNT }
| This specifies the language directional property of a character set. More...
enum | UBlockCode { UBLOCK_NO_BLOCK = 0, UBLOCK_BASIC_LATIN = 1, UBLOCK_LATIN_1_SUPPLEMENT = 2, UBLOCK_LATIN_EXTENDED_A = 3, UBLOCK_LATIN_EXTENDED_B = 4, UBLOCK_IPA_EXTENSIONS = 5, UBLOCK_SPACING_MODIFIER_LETTERS = 6, UBLOCK_COMBINING_DIACRITICAL_MARKS = 7, UBLOCK_GREEK = 8, UBLOCK_CYRILLIC = 9, UBLOCK_ARMENIAN = 10, UBLOCK_HEBREW = 11, UBLOCK_ARABIC = 12, UBLOCK_SYRIAC = 13, UBLOCK_THAANA = 14, UBLOCK_DEVANAGARI = 15, UBLOCK_BENGALI = 16, UBLOCK_GURMUKHI = 17, UBLOCK_GUJARATI = 18, UBLOCK_ORIYA = 19, UBLOCK_TAMIL = 20, UBLOCK_TELUGU = 21, UBLOCK_KANNADA = 22, UBLOCK_MALAYALAM = 23, UBLOCK_SINHALA = 24, UBLOCK_THAI = 25, UBLOCK_LAO = 26, UBLOCK_TIBETAN = 27, UBLOCK_MYANMAR = 28, UBLOCK_GEORGIAN = 29, UBLOCK_HANGUL_JAMO = 30, UBLOCK_ETHIOPIC = 31, UBLOCK_CHEROKEE = 32, UBLOCK_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS = 33, UBLOCK_OGHAM = 34, UBLOCK_RUNIC = 35, UBLOCK_KHMER = 36, UBLOCK_MONGOLIAN = 37, UBLOCK_LATIN_EXTENDED_ADDITIONAL = 38, UBLOCK_GREEK_EXTENDED = 39, UBLOCK_GENERAL_PUNCTUATION = 40, UBLOCK_SUPERSCRIPTS_AND_SUBSCRIPTS = 41, UBLOCK_CURRENCY_SYMBOLS = 42, UBLOCK_COMBINING_MARKS_FOR_SYMBOLS = 43, UBLOCK_LETTERLIKE_SYMBOLS = 44, UBLOCK_NUMBER_FORMS = 45, UBLOCK_ARROWS = 46, UBLOCK_MATHEMATICAL_OPERATORS = 47, UBLOCK_MISCELLANEOUS_TECHNICAL = 48, UBLOCK_CONTROL_PICTURES = 49, UBLOCK_OPTICAL_CHARACTER_RECOGNITION = 50, UBLOCK_ENCLOSED_ALPHANUMERICS = 51, UBLOCK_BOX_DRAWING = 52, UBLOCK_BLOCK_ELEMENTS = 53, UBLOCK_GEOMETRIC_SHAPES = 54, UBLOCK_MISCELLANEOUS_SYMBOLS = 55, UBLOCK_DINGBATS = 56, UBLOCK_BRAILLE_PATTERNS = 57, UBLOCK_CJK_RADICALS_SUPPLEMENT = 58, UBLOCK_KANGXI_RADICALS = 59, UBLOCK_IDEOGRAPHIC_DESCRIPTION_CHARACTERS = 60, UBLOCK_CJK_SYMBOLS_AND_PUNCTUATION = 61, UBLOCK_HIRAGANA = 62, UBLOCK_KATAKANA = 63, UBLOCK_BOPOMOFO = 64, UBLOCK_HANGUL_COMPATIBILITY_JAMO = 65, UBLOCK_KANBUN = 66, UBLOCK_BOPOMOFO_EXTENDED = 67, UBLOCK_ENCLOSED_CJK_LETTERS_AND_MONTHS = 68, UBLOCK_CJK_COMPATIBILITY = 69, UBLOCK_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A = 70, UBLOCK_CJK_UNIFIED_IDEOGRAPHS = 71, UBLOCK_YI_SYLLABLES = 72, UBLOCK_YI_RADICALS = 73, UBLOCK_HANGUL_SYLLABLES = 74, UBLOCK_HIGH_SURROGATES = 75, UBLOCK_HIGH_PRIVATE_USE_SURROGATES = 76, UBLOCK_LOW_SURROGATES = 77, UBLOCK_PRIVATE_USE = 78, UBLOCK_PRIVATE_USE_AREA = UBLOCK_PRIVATE_USE, UBLOCK_CJK_COMPATIBILITY_IDEOGRAPHS = 79, UBLOCK_ALPHABETIC_PRESENTATION_FORMS = 80, UBLOCK_ARABIC_PRESENTATION_FORMS_A = 81, UBLOCK_COMBINING_HALF_MARKS = 82, UBLOCK_CJK_COMPATIBILITY_FORMS = 83, UBLOCK_SMALL_FORM_VARIANTS = 84, UBLOCK_ARABIC_PRESENTATION_FORMS_B = 85, UBLOCK_SPECIALS = 86, UBLOCK_HALFWIDTH_AND_FULLWIDTH_FORMS = 87, UBLOCK_OLD_ITALIC = 88, UBLOCK_GOTHIC = 89, UBLOCK_DESERET = 90, UBLOCK_BYZANTINE_MUSICAL_SYMBOLS = 91, UBLOCK_MUSICAL_SYMBOLS = 92, UBLOCK_MATHEMATICAL_ALPHANUMERIC_SYMBOLS = 93, UBLOCK_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_B = 94, UBLOCK_CJK_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT = 95, UBLOCK_TAGS = 96, UBLOCK_CYRILLIC_SUPPLEMENTARY = 97, UBLOCK_CYRILLIC_SUPPLEMENT = UBLOCK_CYRILLIC_SUPPLEMENTARY, UBLOCK_TAGALOG = 98, UBLOCK_HANUNOO = 99, UBLOCK_BUHID = 100, UBLOCK_TAGBANWA = 101, UBLOCK_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_A = 102, UBLOCK_SUPPLEMENTAL_ARROWS_A = 103, UBLOCK_SUPPLEMENTAL_ARROWS_B = 104, UBLOCK_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_B = 105, UBLOCK_SUPPLEMENTAL_MATHEMATICAL_OPERATORS = 106, UBLOCK_KATAKANA_PHONETIC_EXTENSIONS = 107, UBLOCK_VARIATION_SELECTORS = 108, UBLOCK_SUPPLEMENTARY_PRIVATE_USE_AREA_A = 109, UBLOCK_SUPPLEMENTARY_PRIVATE_USE_AREA_B = 110, UBLOCK_LIMBU = 111, UBLOCK_TAI_LE = 112, UBLOCK_KHMER_SYMBOLS = 113, UBLOCK_PHONETIC_EXTENSIONS = 114, UBLOCK_MISCELLANEOUS_SYMBOLS_AND_ARROWS = 115, UBLOCK_YIJING_HEXAGRAM_SYMBOLS = 116, UBLOCK_LINEAR_B_SYLLABARY = 117, UBLOCK_LINEAR_B_IDEOGRAMS = 118, UBLOCK_AEGEAN_NUMBERS = 119, UBLOCK_UGARITIC = 120, UBLOCK_SHAVIAN = 121, UBLOCK_OSMANYA = 122, UBLOCK_CYPRIOT_SYLLABARY = 123, UBLOCK_TAI_XUAN_JING_SYMBOLS = 124, UBLOCK_VARIATION_SELECTORS_SUPPLEMENT = 125, UBLOCK_ANCIENT_GREEK_MUSICAL_NOTATION = 126, UBLOCK_ANCIENT_GREEK_NUMBERS = 127, UBLOCK_ARABIC_SUPPLEMENT = 128, UBLOCK_BUGINESE = 129, UBLOCK_CJK_STROKES = 130, UBLOCK_COMBINING_DIACRITICAL_MARKS_SUPPLEMENT = 131, UBLOCK_COPTIC = 132, UBLOCK_ETHIOPIC_EXTENDED = 133, UBLOCK_ETHIOPIC_SUPPLEMENT = 134, UBLOCK_GEORGIAN_SUPPLEMENT = 135, UBLOCK_GLAGOLITIC = 136, UBLOCK_KHAROSHTHI = 137, UBLOCK_MODIFIER_TONE_LETTERS = 138, UBLOCK_NEW_TAI_LUE = 139, UBLOCK_OLD_PERSIAN = 140, UBLOCK_PHONETIC_EXTENSIONS_SUPPLEMENT = 141, UBLOCK_SUPPLEMENTAL_PUNCTUATION = 142, UBLOCK_SYLOTI_NAGRI = 143, UBLOCK_TIFINAGH = 144, UBLOCK_VERTICAL_FORMS = 145, UBLOCK_NKO = 146, UBLOCK_BALINESE = 147, UBLOCK_LATIN_EXTENDED_C = 148, UBLOCK_LATIN_EXTENDED_D = 149, UBLOCK_PHAGS_PA = 150, UBLOCK_PHOENICIAN = 151, UBLOCK_CUNEIFORM = 152, UBLOCK_CUNEIFORM_NUMBERS_AND_PUNCTUATION = 153, UBLOCK_COUNTING_ROD_NUMERALS = 154, UBLOCK_SUNDANESE = 155, UBLOCK_LEPCHA = 156, UBLOCK_OL_CHIKI = 157, UBLOCK_CYRILLIC_EXTENDED_A = 158, UBLOCK_VAI = 159, UBLOCK_CYRILLIC_EXTENDED_B = 160, UBLOCK_SAURASHTRA = 161, UBLOCK_KAYAH_LI = 162, UBLOCK_REJANG = 163, UBLOCK_CHAM = 164, UBLOCK_ANCIENT_SYMBOLS = 165, UBLOCK_PHAISTOS_DISC = 166, UBLOCK_LYCIAN = 167, UBLOCK_CARIAN = 168, UBLOCK_LYDIAN = 169, UBLOCK_MAHJONG_TILES = 170, UBLOCK_DOMINO_TILES = 171, UBLOCK_SAMARITAN = 172, UBLOCK_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS_EXTENDED = 173, UBLOCK_TAI_THAM = 174, UBLOCK_VEDIC_EXTENSIONS = 175, UBLOCK_LISU = 176, UBLOCK_BAMUM = 177, UBLOCK_COMMON_INDIC_NUMBER_FORMS = 178, UBLOCK_DEVANAGARI_EXTENDED = 179, UBLOCK_HANGUL_JAMO_EXTENDED_A = 180, UBLOCK_JAVANESE = 181, UBLOCK_MYANMAR_EXTENDED_A = 182, UBLOCK_TAI_VIET = 183, UBLOCK_MEETEI_MAYEK = 184, UBLOCK_HANGUL_JAMO_EXTENDED_B = 185, UBLOCK_IMPERIAL_ARAMAIC = 186, UBLOCK_OLD_SOUTH_ARABIAN = 187, UBLOCK_AVESTAN = 188, UBLOCK_INSCRIPTIONAL_PARTHIAN = 189, UBLOCK_INSCRIPTIONAL_PAHLAVI = 190, UBLOCK_OLD_TURKIC = 191, UBLOCK_RUMI_NUMERAL_SYMBOLS = 192, UBLOCK_KAITHI = 193, UBLOCK_EGYPTIAN_HIEROGLYPHS = 194, UBLOCK_ENCLOSED_ALPHANUMERIC_SUPPLEMENT = 195, UBLOCK_ENCLOSED_IDEOGRAPHIC_SUPPLEMENT = 196, UBLOCK_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_C = 197, UBLOCK_COUNT = 198, UBLOCK_INVALID_CODE = -1 }
| Constants for Unicode blocks, see the Unicode Data file Blocks.txt. More...
enum | UEastAsianWidth { U_EA_NEUTRAL, U_EA_AMBIGUOUS, U_EA_HALFWIDTH, U_EA_FULLWIDTH, U_EA_NARROW, U_EA_WIDE, U_EA_COUNT }
| East Asian Width constants. More...
enum | UCharNameChoice { U_UNICODE_CHAR_NAME, U_UNICODE_10_CHAR_NAME, U_EXTENDED_CHAR_NAME, U_CHAR_NAME_ALIAS, U_CHAR_NAME_CHOICE_COUNT }
| Selector constants for u_charName(). More...
enum | UPropertyNameChoice { U_SHORT_PROPERTY_NAME, U_LONG_PROPERTY_NAME, U_PROPERTY_NAME_CHOICE_COUNT }
| Selector constants for u_getPropertyName() and u_getPropertyValueName(). More...
enum | UDecompositionType { U_DT_NONE, U_DT_CANONICAL, U_DT_COMPAT, U_DT_CIRCLE, U_DT_FINAL, U_DT_FONT, U_DT_FRACTION, U_DT_INITIAL, U_DT_ISOLATED, U_DT_MEDIAL, U_DT_NARROW, U_DT_NOBREAK, U_DT_SMALL, U_DT_SQUARE, U_DT_SUB, U_DT_SUPER, U_DT_VERTICAL, U_DT_WIDE, U_DT_COUNT }
| Decomposition Type constants. More...
enum | UJoiningType { U_JT_NON_JOINING, U_JT_JOIN_CAUSING, U_JT_DUAL_JOINING, U_JT_LEFT_JOINING, U_JT_RIGHT_JOINING, U_JT_TRANSPARENT, U_JT_COUNT }
| Joining Type constants. More...
enum | UJoiningGroup { U_JG_NO_JOINING_GROUP, U_JG_AIN, U_JG_ALAPH, U_JG_ALEF, U_JG_BEH, U_JG_BETH, U_JG_DAL, U_JG_DALATH_RISH, U_JG_E, U_JG_FEH, U_JG_FINAL_SEMKATH, U_JG_GAF, U_JG_GAMAL, U_JG_HAH, U_JG_HAMZA_ON_HEH_GOAL, U_JG_HE, U_JG_HEH, U_JG_HEH_GOAL, U_JG_HETH, U_JG_KAF, U_JG_KAPH, U_JG_KNOTTED_HEH, U_JG_LAM, U_JG_LAMADH, U_JG_MEEM, U_JG_MIM, U_JG_NOON, U_JG_NUN, U_JG_PE, U_JG_QAF, U_JG_QAPH, U_JG_REH, U_JG_REVERSED_PE, U_JG_SAD, U_JG_SADHE, U_JG_SEEN, U_JG_SEMKATH, U_JG_SHIN, U_JG_SWASH_KAF, U_JG_SYRIAC_WAW, U_JG_TAH, U_JG_TAW, U_JG_TEH_MARBUTA, U_JG_TETH, U_JG_WAW, U_JG_YEH, U_JG_YEH_BARREE, U_JG_YEH_WITH_TAIL, U_JG_YUDH, U_JG_YUDH_HE, U_JG_ZAIN, U_JG_FE, U_JG_KHAPH, U_JG_ZHAIN, U_JG_BURUSHASKI_YEH_BARREE, U_JG_FARSI_YEH, U_JG_NYA, U_JG_COUNT }
| Joining Group constants. More...
enum | UGraphemeClusterBreak { U_GCB_OTHER = 0, U_GCB_CONTROL = 1, U_GCB_CR = 2, U_GCB_EXTEND = 3, U_GCB_L = 4, U_GCB_LF = 5, U_GCB_LV = 6, U_GCB_LVT = 7, U_GCB_T = 8, U_GCB_V = 9, U_GCB_SPACING_MARK = 10, U_GCB_PREPEND = 11, U_GCB_COUNT = 12 }
| Grapheme Cluster Break constants. More...
enum | UWordBreakValues { U_WB_OTHER = 0, U_WB_ALETTER = 1, U_WB_FORMAT = 2, U_WB_KATAKANA = 3, U_WB_MIDLETTER = 4, U_WB_MIDNUM = 5, U_WB_NUMERIC = 6, U_WB_EXTENDNUMLET = 7, U_WB_CR = 8, U_WB_EXTEND = 9, U_WB_LF = 10, U_WB_MIDNUMLET = 11, U_WB_NEWLINE = 12, U_WB_COUNT = 13 }
| Word Break constants. More...
enum | USentenceBreak { U_SB_OTHER = 0, U_SB_ATERM = 1, U_SB_CLOSE = 2, U_SB_FORMAT = 3, U_SB_LOWER = 4, U_SB_NUMERIC = 5, U_SB_OLETTER = 6, U_SB_SEP = 7, U_SB_SP = 8, U_SB_STERM = 9, U_SB_UPPER = 10, U_SB_CR = 11, U_SB_EXTEND = 12, U_SB_LF = 13, U_SB_SCONTINUE = 14, U_SB_COUNT = 15 }
| Sentence Break constants. More...
enum | ULineBreak { U_LB_UNKNOWN = 0, U_LB_AMBIGUOUS = 1, U_LB_ALPHABETIC = 2, U_LB_BREAK_BOTH = 3, U_LB_BREAK_AFTER = 4, U_LB_BREAK_BEFORE = 5, U_LB_MANDATORY_BREAK = 6, U_LB_CONTINGENT_BREAK = 7, U_LB_CLOSE_PUNCTUATION = 8, U_LB_COMBINING_MARK = 9, U_LB_CARRIAGE_RETURN = 10, U_LB_EXCLAMATION = 11, U_LB_GLUE = 12, U_LB_HYPHEN = 13, U_LB_IDEOGRAPHIC = 14, U_LB_INSEPERABLE = 15, U_LB_INSEPARABLE = U_LB_INSEPERABLE, U_LB_INFIX_NUMERIC = 16, U_LB_LINE_FEED = 17, U_LB_NONSTARTER = 18, U_LB_NUMERIC = 19, U_LB_OPEN_PUNCTUATION = 20, U_LB_POSTFIX_NUMERIC = 21, U_LB_PREFIX_NUMERIC = 22, U_LB_QUOTATION = 23, U_LB_COMPLEX_CONTEXT = 24, U_LB_SURROGATE = 25, U_LB_SPACE = 26, U_LB_BREAK_SYMBOLS = 27, U_LB_ZWSPACE = 28, U_LB_NEXT_LINE = 29, U_LB_WORD_JOINER = 30, U_LB_H2 = 31, U_LB_H3 = 32, U_LB_JL = 33, U_LB_JT = 34, U_LB_JV = 35, U_LB_CLOSE_PARENTHESIS = 36, U_LB_COUNT = 37 }
| Line Break constants. More...
enum | UNumericType { U_NT_NONE, U_NT_DECIMAL, U_NT_DIGIT, U_NT_NUMERIC, U_NT_COUNT }
| Numeric Type constants. More...
enum | UHangulSyllableType { U_HST_NOT_APPLICABLE, U_HST_LEADING_JAMO, U_HST_VOWEL_JAMO, U_HST_TRAILING_JAMO, U_HST_LV_SYLLABLE, U_HST_LVT_SYLLABLE, U_HST_COUNT }
| Hangul Syllable Type constants. More...
## Functions
UBool | u_hasBinaryProperty (UChar32 c, UProperty which)
| Check a binary Unicode property for a code point.
UBool | u_isUAlphabetic (UChar32 c)
| Check if a code point has the Alphabetic Unicode property.
UBool | u_isULowercase (UChar32 c)
| Check if a code point has the Lowercase Unicode property.
UBool | u_isUUppercase (UChar32 c)
| Check if a code point has the Uppercase Unicode property.
UBool | u_isUWhiteSpace (UChar32 c)
| Check if a code point has the White_Space Unicode property.
int32_t | u_getIntPropertyValue (UChar32 c, UProperty which)
| Get the property value for an enumerated or integer Unicode property for a code point.
int32_t | u_getIntPropertyMinValue (UProperty which)
| Get the minimum value for an enumerated/integer/binary Unicode property.
int32_t | u_getIntPropertyMaxValue (UProperty which)
| Get the maximum value for an enumerated/integer/binary Unicode property.
double | u_getNumericValue (UChar32 c)
| Get the numeric value for a Unicode code point as defined in the Unicode Character Database.
UBool | u_islower (UChar32 c)
| Determines whether the specified code point has the general category "Ll" (lowercase letter).
UBool | u_isupper (UChar32 c)
| Determines whether the specified code point has the general category "Lu" (uppercase letter).
UBool | u_istitle (UChar32 c)
| Determines whether the specified code point is a titlecase letter.
UBool | u_isdigit (UChar32 c)
| Determines whether the specified code point is a digit character according to Java.
UBool | u_isalpha (UChar32 c)
| Determines whether the specified code point is a letter character.
UBool | u_isalnum (UChar32 c)
| Determines whether the specified code point is an alphanumeric character (letter or digit) according to Java.
UBool | u_isxdigit (UChar32 c)
| Determines whether the specified code point is a hexadecimal digit.
UBool | u_ispunct (UChar32 c)
| Determines whether the specified code point is a punctuation character.
UBool | u_isgraph (UChar32 c)
| Determines whether the specified code point is a "graphic" character (printable, excluding spaces).
UBool | u_isblank (UChar32 c)
| Determines whether the specified code point is a "blank" or "horizontal space", a character that visibly separates words on a line.
UBool | u_isdefined (UChar32 c)
| Determines whether the specified code point is "defined", which usually means that it is assigned a character.
UBool | u_isspace (UChar32 c)
| Determines if the specified character is a space character or not.
UBool | u_isJavaSpaceChar (UChar32 c)
| Determine if the specified code point is a space character according to Java.
UBool | u_isWhitespace (UChar32 c)
| Determines if the specified code point is a whitespace character according to Java/ICU.
UBool | u_iscntrl (UChar32 c)
| Determines whether the specified code point is a control character (as defined by this function).
UBool | u_isISOControl (UChar32 c)
| Determines whether the specified code point is an ISO control code.
UBool | u_isprint (UChar32 c)
| Determines whether the specified code point is a printable character.
UBool | u_isbase (UChar32 c)
| Determines whether the specified code point is a base character.
UCharDirection | u_charDirection (UChar32 c)
| Returns the bidirectional category value for the code point, which is used in the Unicode bidirectional algorithm (UAX #9 http://www.unicode.org/reports/tr9/).
UBool | u_isMirrored (UChar32 c)
| Determines whether the code point has the Bidi_Mirrored property.
UChar32 | u_charMirror (UChar32 c)
| Maps the specified character to a "mirror-image" character.
int8_t | u_charType (UChar32 c)
| Returns the general category value for the code point.
void | u_enumCharTypes (UCharEnumTypeRange *enumRange, const void *context)
| Enumerate efficiently all code points with their Unicode general categories.
uint8_t | u_getCombiningClass (UChar32 c)
| Returns the combining class of the code point as specified in UnicodeData.txt.
int32_t | u_charDigitValue (UChar32 c)
| Returns the decimal digit value of a decimal digit character.
UBlockCode | ublock_getCode (UChar32 c)
| Returns the Unicode allocation block that contains the character.
int32_t | u_charName (UChar32 code, UCharNameChoice nameChoice, char *buffer, int32_t bufferLength, UErrorCode *pErrorCode)
| Retrieve the name of a Unicode character.
int32_t | u_getISOComment (UChar32 c, char *dest, int32_t destCapacity, UErrorCode *pErrorCode)
| Get the ISO 10646 comment for a character.
UChar32 | u_charFromName (UCharNameChoice nameChoice, const char *name, UErrorCode *pErrorCode)
| Find a Unicode character by its name and return its code point value.
void | u_enumCharNames (UChar32 start, UChar32 limit, UEnumCharNamesFn *fn, void *context, UCharNameChoice nameChoice, UErrorCode *pErrorCode)
| Enumerate all assigned Unicode characters between the start and limit code points (start inclusive, limit exclusive) and call a function for each, passing the code point value and the character name.
const char * | u_getPropertyName (UProperty property, UPropertyNameChoice nameChoice)
| Return the Unicode name for a given property, as given in the Unicode database file PropertyAliases.txt.
UProperty | u_getPropertyEnum (const char *alias)
| Return the UProperty enum for a given property name, as specified in the Unicode database file PropertyAliases.txt.
const char * | u_getPropertyValueName (UProperty property, int32_t value, UPropertyNameChoice nameChoice)
| Return the Unicode name for a given property value, as given in the Unicode database file PropertyValueAliases.txt.
int32_t | u_getPropertyValueEnum (UProperty property, const char *alias)
| Return the property value integer for a given value name, as specified in the Unicode database file PropertyValueAliases.txt.
UBool | u_isIDStart (UChar32 c)
| Determines if the specified character is permissible as the first character in an identifier according to Unicode (The Unicode Standard, Version 3.0, chapter 5.16 Identifiers).
UBool | u_isIDPart (UChar32 c)
| Determines if the specified character is permissible in an identifier according to Java.
UBool | u_isIDIgnorable (UChar32 c)
| Determines if the specified character should be regarded as an ignorable character in an identifier, according to Java.
UBool | u_isJavaIDStart (UChar32 c)
| Determines if the specified character is permissible as the first character in a Java identifier.
UBool | u_isJavaIDPart (UChar32 c)
| Determines if the specified character is permissible in a Java identifier.
UChar32 | u_tolower (UChar32 c)
| The given character is mapped to its lowercase equivalent according to UnicodeData.txt; if the character has no lowercase equivalent, the character itself is returned.
UChar32 | u_toupper (UChar32 c)
| The given character is mapped to its uppercase equivalent according to UnicodeData.txt; if the character has no uppercase equivalent, the character itself is returned.
UChar32 | u_totitle (UChar32 c)
| The given character is mapped to its titlecase equivalent according to UnicodeData.txt; if none is defined, the character itself is returned.
UChar32 | u_foldCase (UChar32 c, uint32_t options)
| The given character is mapped to its case folding equivalent according to UnicodeData.txt and CaseFolding.txt; if the character has no case folding equivalent, the character itself is returned.
int32_t | u_digit (UChar32 ch, int8_t radix)
| Returns the decimal digit value of the code point in the specified radix.
UChar32 | u_forDigit (int32_t digit, int8_t radix)
| Determines the character representation for a specific digit in the specified radix.
void | u_charAge (UChar32 c, UVersionInfo versionArray)
| Get the "age" of the code point.
void | u_getUnicodeVersion (UVersionInfo versionArray)
| Gets the Unicode version information.
int32_t | u_getFC_NFKC_Closure (UChar32 c, UChar *dest, int32_t destCapacity, UErrorCode *pErrorCode)
| Get the FC_NFKC_Closure property string for a character.

## Detailed Description

C API: Unicode Properties.

This C API provides low-level access to the Unicode Character Database. In addition to raw property values, some convenience functions calculate derived properties, for example for Java-style programming.

Unicode assigns each code point (not just assigned character) values for many properties. Most of them are simple boolean flags, or constants from a small enumerated list. For some properties, values are strings or other relatively more complex types.

For more information see "About the Unicode Character Database" (http://www.unicode.org/ucd/) and the ICU User Guide chapter on Properties (http://icu-project.org/userguide/properties.html).

Many functions are designed to match java.lang.Character functions. See the individual function documentation, and see the JDK 1.4 java.lang.Character documentation at http://java.sun.com/j2se/1.4/docs/api/java/lang/Character.html

There are also functions that provide easy migration from C/POSIX functions like isblank(). Their use is generally discouraged because the C/POSIX standards do not define their semantics beyond the ASCII range, which means that different implementations exhibit very different behavior. Instead, Unicode properties should be used directly.

There are also only a few, broad C/POSIX character classes, and they tend to be used for conflicting purposes. For example, the "isalpha()" class is sometimes used to determine word boundaries, while a more sophisticated approach would at least distinguish initial letters from continuation characters (the latter including combining marks). (In ICU, BreakIterator is the most sophisticated API for word boundaries.) Another example: There is no "istitle()" class for titlecase characters.

ICU 3.4 and later provides API access for all twelve C/POSIX character classes. ICU implements them according to the Standard Recommendations in Annex C: Compatibility Properties of UTS #18 Unicode Regular Expressions (http://www.unicode.org/reports/tr18/#Compatibility_Properties).

API access for C/POSIX character classes is as follows:

- alpha: u_isUAlphabetic(c) or u_hasBinaryProperty(c, UCHAR_ALPHABETIC)
- lower: u_isULowercase(c) or u_hasBinaryProperty(c, UCHAR_LOWERCASE)
- upper: u_isUUppercase(c) or u_hasBinaryProperty(c, UCHAR_UPPERCASE)
- punct: u_ispunct(c)
- digit: u_isdigit(c) or u_charType(c)==U_DECIMAL_DIGIT_NUMBER
- xdigit: u_isxdigit(c) or u_hasBinaryProperty(c, UCHAR_POSIX_XDIGIT)
- alnum: u_hasBinaryProperty(c, UCHAR_POSIX_ALNUM)
- space: u_isUWhiteSpace(c) or u_hasBinaryProperty(c, UCHAR_WHITE_SPACE)
- blank: u_isblank(c) or u_hasBinaryProperty(c, UCHAR_POSIX_BLANK)
- cntrl: u_charType(c)==U_CONTROL_CHAR
- graph: u_hasBinaryProperty(c, UCHAR_POSIX_GRAPH)
- print: u_hasBinaryProperty(c, UCHAR_POSIX_PRINT)

Note: Some of the u_isxyz() functions in uchar.h predate, and do not match, the Standard Recommendations in UTS #18. Instead, they match Java functions according to their API documentation.

The C/POSIX character classes are also available in UnicodeSet patterns, using patterns like [:graph:] or \p{graph}.

Note: There are several ICU whitespace functions. Comparison:

- u_isUWhiteSpace=UCHAR_WHITE_SPACE: Unicode White_Space property; most of general categories "Z" (separators) + most whitespace ISO controls (including no-break spaces, but excluding IS1..IS4 and ZWSP)
- u_isWhitespace: Java isWhitespace; Z + whitespace ISO controls but excluding no-break spaces
- u_isJavaSpaceChar: Java isSpaceChar; just Z (including no-break spaces)
- u_isspace: Z + whitespace ISO controls (including no-break spaces)
- u_isblank: "horizontal spaces" = TAB + Zs - ZWSP

Definition in file uchar.h.

## Define Documentation

#define U_FOLD_CASE_DEFAULT 0

Option value for case folding: use default mappings defined in CaseFolding.txt.

Stable:
  ICU 2.0

Definition at line 2947 of file uchar.h.

#define U_FOLD_CASE_EXCLUDE_SPECIAL_I 1

Option value for case folding:.

Use the modified set of mappings provided in CaseFolding.txt to handle dotted I and dotless i appropriately for Turkic languages (tr, az).

Before Unicode 3.2, CaseFolding.txt contains mappings marked with 'I' that are to be included for default mappings and excluded for the Turkic-specific mappings.

Unicode 3.2 CaseFolding.txt instead contains mappings marked with 'T' that are to be excluded for default mappings and included for the Turkic-specific mappings.

Stable:
  ICU 2.0

Definition at line 2965 of file uchar.h.

#define U_GC_C_MASK (U_GC_CN_MASK|U_GC_CC_MASK|U_GC_CF_MASK|U_GC_CO_MASK|U_GC_CS_MASK)

Mask constant for multiple UCharCategory bits (C Others).

Stable:
  ICU 2.1

Definition at line 743 of file uchar.h.

#define U_GC_CC_MASK U_MASK(U_CONTROL_CHAR)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 691 of file uchar.h.

#define U_GC_CF_MASK U_MASK(U_FORMAT_CHAR)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 693 of file uchar.h.

#define U_GC_CN_MASK U_MASK(U_GENERAL_OTHER_TYPES)

U_GC_XX_MASK constants are bit flags corresponding to Unicode general category values.

For each category, the nth bit is set if the numeric value of the corresponding UCharCategory constant is n.

There are also some U_GC_Y_MASK constants for groups of general categories like L for all letter categories.

See also:
  u_charType
  U_GET_GC_MASK
  UCharCategory

Stable:
  ICU 2.1

Definition at line 656 of file uchar.h.

#define U_GC_CO_MASK U_MASK(U_PRIVATE_USE_CHAR)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 695 of file uchar.h.

#define U_GC_CS_MASK U_MASK(U_SURROGATE)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 697 of file uchar.h.

#define U_GC_L_MASK (U_GC_LU_MASK|U_GC_LL_MASK|U_GC_LT_MASK|U_GC_LM_MASK|U_GC_LO_MASK)

Mask constant for multiple UCharCategory bits (L Letters).

Stable:
  ICU 2.1

Definition at line 726 of file uchar.h.

#define U_GC_LC_MASK (U_GC_LU_MASK|U_GC_LL_MASK|U_GC_LT_MASK)

Mask constant for multiple UCharCategory bits (LC Cased Letters).

Stable:
  ICU 2.1

Definition at line 730 of file uchar.h.

#define U_GC_LL_MASK U_MASK(U_LOWERCASE_LETTER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 661 of file uchar.h.

#define U_GC_LM_MASK U_MASK(U_MODIFIER_LETTER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 665 of file uchar.h.

#define U_GC_LO_MASK U_MASK(U_OTHER_LETTER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 667 of file uchar.h.

#define U_GC_LT_MASK U_MASK(U_TITLECASE_LETTER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 663 of file uchar.h.

#define U_GC_LU_MASK U_MASK(U_UPPERCASE_LETTER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 659 of file uchar.h.

#define U_GC_M_MASK (U_GC_MN_MASK|U_GC_ME_MASK|U_GC_MC_MASK)

Mask constant for multiple UCharCategory bits (M Marks).

Stable:
  ICU 2.1

Definition at line 734 of file uchar.h.

#define U_GC_MC_MASK U_MASK(U_COMBINING_SPACING_MARK)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 674 of file uchar.h.

#define U_GC_ME_MASK U_MASK(U_ENCLOSING_MARK)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 672 of file uchar.h.

#define U_GC_MN_MASK U_MASK(U_NON_SPACING_MARK)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 670 of file uchar.h.

#define U_GC_N_MASK (U_GC_ND_MASK|U_GC_NL_MASK|U_GC_NO_MASK)

Mask constant for multiple UCharCategory bits (N Numbers).

Stable:
  ICU 2.1

Definition at line 737 of file uchar.h.

#define U_GC_ND_MASK U_MASK(U_DECIMAL_DIGIT_NUMBER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 677 of file uchar.h.

#define U_GC_NL_MASK U_MASK(U_LETTER_NUMBER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 679 of file uchar.h.

#define U_GC_NO_MASK U_MASK(U_OTHER_NUMBER)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 681 of file uchar.h.

#define U_GC_P_MASK

Value:

    (U_GC_PD_MASK|U_GC_PS_MASK|U_GC_PE_MASK|U_GC_PC_MASK|U_GC_PO_MASK| \
                 U_GC_PI_MASK|U_GC_PF_MASK)

Mask constant for multiple UCharCategory bits (P Punctuation).

Stable:
  ICU 2.1

Definition at line 747 of file uchar.h.

#define U_GC_PC_MASK U_MASK(U_CONNECTOR_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 706 of file uchar.h.

#define U_GC_PD_MASK U_MASK(U_DASH_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 700 of file uchar.h.

#define U_GC_PE_MASK U_MASK(U_END_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 704 of file uchar.h.

#define U_GC_PF_MASK U_MASK(U_FINAL_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 722 of file uchar.h.

#define U_GC_PI_MASK U_MASK(U_INITIAL_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 720 of file uchar.h.

#define U_GC_PO_MASK U_MASK(U_OTHER_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 708 of file uchar.h.

#define U_GC_PS_MASK U_MASK(U_START_PUNCTUATION)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 702 of file uchar.h.

#define U_GC_S_MASK (U_GC_SM_MASK|U_GC_SC_MASK|U_GC_SK_MASK|U_GC_SO_MASK)

Mask constant for multiple UCharCategory bits (S Symbols).

Stable:
  ICU 2.1

Definition at line 752 of file uchar.h.

#define U_GC_SC_MASK U_MASK(U_CURRENCY_SYMBOL)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 713 of file uchar.h.

#define U_GC_SK_MASK U_MASK(U_MODIFIER_SYMBOL)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 715 of file uchar.h.

#define U_GC_SM_MASK U_MASK(U_MATH_SYMBOL)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 711 of file uchar.h.

#define U_GC_SO_MASK U_MASK(U_OTHER_SYMBOL)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 717 of file uchar.h.

#define U_GC_Z_MASK (U_GC_ZS_MASK|U_GC_ZL_MASK|U_GC_ZP_MASK)

Mask constant for multiple UCharCategory bits (Z Separators).

Stable:
  ICU 2.1

Definition at line 740 of file uchar.h.

#define U_GC_ZL_MASK U_MASK(U_LINE_SEPARATOR)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 686 of file uchar.h.

#define U_GC_ZP_MASK U_MASK(U_PARAGRAPH_SEPARATOR)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 688 of file uchar.h.

#define U_GC_ZS_MASK U_MASK(U_SPACE_SEPARATOR)

Mask constant for a UCharCategory.

Stable:
  ICU 2.1

Definition at line 684 of file uchar.h.

#define U_GET_GC_MASK | ( | c |  | ) | U_MASK(u_charType(c))

Get a single-bit bit set for the general category of a character.

This bit set can be compared bitwise with U_GC_SM_MASK, U_GC_L_MASK, etc. Same as U_MASK(u_charType(c)).

Parameters:

  | c | the code point to be tested

Returns:
  a single-bit mask corresponding to the general category (UCharCategory) value

See also:
  u_charType
  UCharCategory
  U_GC_CN_MASK

Stable:
  ICU 2.1

Definition at line 2381 of file uchar.h.

#define U_MASK | ( | x |  | ) | ((uint32_t)1<<(x))

Get a single-bit bit set (a flag) from a bit number 0..31.

Stable:
  ICU 2.1

Definition at line 140 of file uchar.h.

#define U_NO_NUMERIC_VALUE ((double)-123456789.)

Special value that is returned by u_getNumericValue when no numeric value is defined for a code point.

See also:
  u_getNumericValue

Stable:
  ICU 2.2

Definition at line 1888 of file uchar.h.

#define U_UNICODE_VERSION "5.2"

Unicode version number, default for the current ICU version.

The actual Unicode Character Database (UCD) data is stored in uprops.dat and may be generated from UCD files from a different Unicode version. Call u_getUnicodeVersion to get the actual Unicode version of the data.

See also:
  u_getUnicodeVersion

Stable:
  ICU 2.0

Definition at line 42 of file uchar.h.

#define UCHAR_MAX_VALUE 0x10ffff

The highest Unicode code point value (scalar value) according to The Unicode Standard.

This is a 21-bit value (20.1 bits, rounded up). For a single character, UChar32 is a simple type that can hold any code point value.

See also:
  UChar32

Stable:
  ICU 2.0

Definition at line 134 of file uchar.h.

#define UCHAR_MIN_VALUE 0

Constants.

The lowest Unicode code point value. Code points are non-negative.

Stable:
  ICU 2.0

Definition at line 124 of file uchar.h.

## Typedef Documentation

typedef enum UBlockCode UBlockCode

Stable:
  ICU 2.0

Definition at line 1351 of file uchar.h.

typedef UBool UCharEnumTypeRange(const void *context, UChar32 start, UChar32 limit, UCharCategory type)

Callback from u_enumCharTypes(), is called for each contiguous range of code points c (where start<=c<limit) with the same Unicode general category ("character type").

The callback function can stop the enumeration by returning FALSE.

Parameters:

  | context | an opaque pointer, as passed into utrie_enum()
  | start | the first code point in a contiguous range with value
  | limit | one past the last code point in a contiguous range with value
  | type | the general category for all code points in [start..limit[

Returns:
  FALSE to stop the enumeration

Stable:
  ICU 2.1

See also:
  UCharCategory
  u_enumCharTypes

Definition at line 2401 of file uchar.h.

typedef UBool UEnumCharNamesFn(void *context, UChar32 code, UCharNameChoice nameChoice, const char *name, int32_t length)

Type of a callback function for u_enumCharNames() that gets called for each Unicode character with the code point value and the character name.

If such a function returns FALSE, then the enumeration is stopped.

Parameters:

  | context | The context pointer that was passed to u_enumCharNames().
  | code | The Unicode code point for the character with this name.
  | nameChoice | Selector for which kind of names is enumerated.
  | name | The character's name, zero-terminated.
  | length | The length of the name.

Returns:
  TRUE if the enumeration should continue, FALSE to stop it.

See also:
  UCharNameChoice
  u_enumCharNames

Stable:
  ICU 1.7

Definition at line 2586 of file uchar.h.

## Enumeration Type Documentation

enum UBlockCode

Constants for Unicode blocks, see the Unicode Data file Blocks.txt.

Stable:
  ICU 2.0

Enumerator:

  UBLOCK_NO_BLOCK | New No_Block value in Unicode 4. Stable: ICU 2.6
  UBLOCK_BASIC_LATIN | Stable: ICU 2.0
  UBLOCK_LATIN_1_SUPPLEMENT | Stable: ICU 2.0
  UBLOCK_LATIN_EXTENDED_A | Stable: ICU 2.0
  UBLOCK_LATIN_EXTENDED_B | Stable: ICU 2.0
  UBLOCK_IPA_EXTENSIONS | Stable: ICU 2.0
  UBLOCK_SPACING_MODIFIER_LETTERS | Stable: ICU 2.0
  UBLOCK_COMBINING_DIACRITICAL_MARKS | Stable: ICU 2.0
  UBLOCK_GREEK | Unicode 3.2 renames this block to "Greek and Coptic". Stable: ICU 2.0
  UBLOCK_CYRILLIC | Stable: ICU 2.0
  UBLOCK_ARMENIAN | Stable: ICU 2.0
  UBLOCK_HEBREW | Stable: ICU 2.0
  UBLOCK_ARABIC | Stable: ICU 2.0
  UBLOCK_SYRIAC | Stable: ICU 2.0
  UBLOCK_THAANA | Stable: ICU 2.0
  UBLOCK_DEVANAGARI | Stable: ICU 2.0
  UBLOCK_BENGALI | Stable: ICU 2.0
  UBLOCK_GURMUKHI | Stable: ICU 2.0
  UBLOCK_GUJARATI | Stable: ICU 2.0
  UBLOCK_ORIYA | Stable: ICU 2.0
  UBLOCK_TAMIL | Stable: ICU 2.0
  UBLOCK_TELUGU | Stable: ICU 2.0
  UBLOCK_KANNADA | Stable: ICU 2.0
  UBLOCK_MALAYALAM | Stable: ICU 2.0
  UBLOCK_SINHALA | Stable: ICU 2.0
  UBLOCK_THAI | Stable: ICU 2.0
  UBLOCK_LAO | Stable: ICU 2.0
  UBLOCK_TIBETAN | Stable: ICU 2.0
  UBLOCK_MYANMAR | Stable: ICU 2.0
  UBLOCK_GEORGIAN | Stable: ICU 2.0
  UBLOCK_HANGUL_JAMO | Stable: ICU 2.0
  UBLOCK_ETHIOPIC | Stable: ICU 2.0
  UBLOCK_CHEROKEE | Stable: ICU 2.0
  UBLOCK_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS | Stable: ICU 2.0
  UBLOCK_OGHAM | Stable: ICU 2.0
  UBLOCK_RUNIC | Stable: ICU 2.0
  UBLOCK_KHMER | Stable: ICU 2.0
  UBLOCK_MONGOLIAN | Stable: ICU 2.0
  UBLOCK_LATIN_EXTENDED_ADDITIONAL | Stable: ICU 2.0
  UBLOCK_GREEK_EXTENDED | Stable: ICU 2.0
  UBLOCK_GENERAL_PUNCTUATION | Stable: ICU 2.0
  UBLOCK_SUPERSCRIPTS_AND_SUBSCRIPTS | Stable: ICU 2.0
  UBLOCK_CURRENCY_SYMBOLS | Stable: ICU 2.0
  UBLOCK_COMBINING_MARKS_FOR_SYMBOLS | Unicode 3.2 renames this block to "Combining Diacritical Marks for Symbols". Stable: ICU 2.0
  UBLOCK_LETTERLIKE_SYMBOLS | Stable: ICU 2.0
  UBLOCK_NUMBER_FORMS | Stable: ICU 2.0
  UBLOCK_ARROWS | Stable: ICU 2.0
  UBLOCK_MATHEMATICAL_OPERATORS | Stable: ICU 2.0
  UBLOCK_MISCELLANEOUS_TECHNICAL | Stable: ICU 2.0
  UBLOCK_CONTROL_PICTURES | Stable: ICU 2.0
  UBLOCK_OPTICAL_CHARACTER_RECOGNITION | Stable: ICU 2.0
  UBLOCK_ENCLOSED_ALPHANUMERICS | Stable: ICU 2.0
  UBLOCK_BOX_DRAWING | Stable: ICU 2.0
  UBLOCK_BLOCK_ELEMENTS | Stable: ICU 2.0
  UBLOCK_GEOMETRIC_SHAPES | Stable: ICU 2.0
  UBLOCK_MISCELLANEOUS_SYMBOLS | Stable: ICU 2.0
  UBLOCK_DINGBATS | Stable: ICU 2.0
  UBLOCK_BRAILLE_PATTERNS | Stable: ICU 2.0
  UBLOCK_CJK_RADICALS_SUPPLEMENT | Stable: ICU 2.0
  UBLOCK_KANGXI_RADICALS | Stable: ICU 2.0
  UBLOCK_IDEOGRAPHIC_DESCRIPTION_CHARACTERS | Stable: ICU 2.0
  UBLOCK_CJK_SYMBOLS_AND_PUNCTUATION | Stable: ICU 2.0
  UBLOCK_HIRAGANA | Stable: ICU 2.0
  UBLOCK_KATAKANA | Stable: ICU 2.0
  UBLOCK_BOPOMOFO | Stable: ICU 2.0
  UBLOCK_HANGUL_COMPATIBILITY_JAMO | Stable: ICU 2.0
  UBLOCK_KANBUN | Stable: ICU 2.0
  UBLOCK_BOPOMOFO_EXTENDED | Stable: ICU 2.0
  UBLOCK_ENCLOSED_CJK_LETTERS_AND_MONTHS | Stable: ICU 2.0
  UBLOCK_CJK_COMPATIBILITY | Stable: ICU 2.0
  UBLOCK_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A | Stable: ICU 2.0
  UBLOCK_CJK_UNIFIED_IDEOGRAPHS | Stable: ICU 2.0
  UBLOCK_YI_SYLLABLES | Stable: ICU 2.0
  UBLOCK_YI_RADICALS | Stable: ICU 2.0
  UBLOCK_HANGUL_SYLLABLES | Stable: ICU 2.0
  UBLOCK_HIGH_SURROGATES | Stable: ICU 2.0
  UBLOCK_HIGH_PRIVATE_USE_SURROGATES | Stable: ICU 2.0
  UBLOCK_LOW_SURROGATES | Stable: ICU 2.0
  UBLOCK_PRIVATE_USE | Same as UBLOCK_PRIVATE_USE_AREA. Until Unicode 3.1.1, the corresponding block name was "Private Use", and multiple code point ranges had this block. Unicode 3.2 renames the block for the BMP PUA to "Private Use Area" and adds separate blocks for the supplementary PUAs. Stable: ICU 2.0
  UBLOCK_PRIVATE_USE_AREA | Same as UBLOCK_PRIVATE_USE. Until Unicode 3.1.1, the corresponding block name was "Private Use", and multiple code point ranges had this block. Unicode 3.2 renames the block for the BMP PUA to "Private Use Area" and adds separate blocks for the supplementary PUAs. Stable: ICU 2.0
  UBLOCK_CJK_COMPATIBILITY_IDEOGRAPHS | Stable: ICU 2.0
  UBLOCK_ALPHABETIC_PRESENTATION_FORMS | Stable: ICU 2.0
  UBLOCK_ARABIC_PRESENTATION_FORMS_A | Stable: ICU 2.0
  UBLOCK_COMBINING_HALF_MARKS | Stable: ICU 2.0
  UBLOCK_CJK_COMPATIBILITY_FORMS | Stable: ICU 2.0
  UBLOCK_SMALL_FORM_VARIANTS | Stable: ICU 2.0
  UBLOCK_ARABIC_PRESENTATION_FORMS_B | Stable: ICU 2.0
  UBLOCK_SPECIALS | Stable: ICU 2.0
  UBLOCK_HALFWIDTH_AND_FULLWIDTH_FORMS | Stable: ICU 2.0
  UBLOCK_OLD_ITALIC | Stable: ICU 2.0
  UBLOCK_GOTHIC | Stable: ICU 2.0
  UBLOCK_DESERET | Stable: ICU 2.0
  UBLOCK_BYZANTINE_MUSICAL_SYMBOLS | Stable: ICU 2.0
  UBLOCK_MUSICAL_SYMBOLS | Stable: ICU 2.0
  UBLOCK_MATHEMATICAL_ALPHANUMERIC_SYMBOLS | Stable: ICU 2.0
  UBLOCK_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_B | Stable: ICU 2.0
  UBLOCK_CJK_COMPATIBILITY_IDEOGRAPHS_SUPPLEMENT | Stable: ICU 2.0
  UBLOCK_TAGS | Stable: ICU 2.0
  UBLOCK_CYRILLIC_SUPPLEMENTARY | Unicode 4.0.1 renames the "Cyrillic Supplementary" block to "Cyrillic Supplement". Stable: ICU 2.2
  UBLOCK_CYRILLIC_SUPPLEMENT | Stable: ICU 3.0
  UBLOCK_TAGALOG | Stable: ICU 2.2
  UBLOCK_HANUNOO | Stable: ICU 2.2
  UBLOCK_BUHID | Stable: ICU 2.2
  UBLOCK_TAGBANWA | Stable: ICU 2.2
  UBLOCK_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_A | Stable: ICU 2.2
  UBLOCK_SUPPLEMENTAL_ARROWS_A | Stable: ICU 2.2
  UBLOCK_SUPPLEMENTAL_ARROWS_B | Stable: ICU 2.2
  UBLOCK_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_B | Stable: ICU 2.2
  UBLOCK_SUPPLEMENTAL_MATHEMATICAL_OPERATORS | Stable: ICU 2.2
  UBLOCK_KATAKANA_PHONETIC_EXTENSIONS | Stable: ICU 2.2
  UBLOCK_VARIATION_SELECTORS | Stable: ICU 2.2
  UBLOCK_SUPPLEMENTARY_PRIVATE_USE_AREA_A | Stable: ICU 2.2
  UBLOCK_SUPPLEMENTARY_PRIVATE_USE_AREA_B | Stable: ICU 2.2
  UBLOCK_LIMBU | Stable: ICU 2.6
  UBLOCK_TAI_LE | Stable: ICU 2.6
  UBLOCK_KHMER_SYMBOLS | Stable: ICU 2.6
  UBLOCK_PHONETIC_EXTENSIONS | Stable: ICU 2.6
  UBLOCK_MISCELLANEOUS_SYMBOLS_AND_ARROWS | Stable: ICU 2.6
  UBLOCK_YIJING_HEXAGRAM_SYMBOLS | Stable: ICU 2.6
  UBLOCK_LINEAR_B_SYLLABARY | Stable: ICU 2.6
  UBLOCK_LINEAR_B_IDEOGRAMS | Stable: ICU 2.6
  UBLOCK_AEGEAN_NUMBERS | Stable: ICU 2.6
  UBLOCK_UGARITIC | Stable: ICU 2.6
  UBLOCK_SHAVIAN | Stable: ICU 2.6
  UBLOCK_OSMANYA | Stable: ICU 2.6
  UBLOCK_CYPRIOT_SYLLABARY | Stable: ICU 2.6
  UBLOCK_TAI_XUAN_JING_SYMBOLS | Stable: ICU 2.6
  UBLOCK_VARIATION_SELECTORS_SUPPLEMENT | Stable: ICU 2.6
  UBLOCK_ANCIENT_GREEK_MUSICAL_NOTATION | Stable: ICU 3.4
  UBLOCK_ANCIENT_GREEK_NUMBERS | Stable: ICU 3.4
  UBLOCK_ARABIC_SUPPLEMENT | Stable: ICU 3.4
  UBLOCK_BUGINESE | Stable: ICU 3.4
  UBLOCK_CJK_STROKES | Stable: ICU 3.4
  UBLOCK_COMBINING_DIACRITICAL_MARKS_SUPPLEMENT | Stable: ICU 3.4
  UBLOCK_COPTIC | Stable: ICU 3.4
  UBLOCK_ETHIOPIC_EXTENDED | Stable: ICU 3.4
  UBLOCK_ETHIOPIC_SUPPLEMENT | Stable: ICU 3.4
  UBLOCK_GEORGIAN_SUPPLEMENT | Stable: ICU 3.4
  UBLOCK_GLAGOLITIC | Stable: ICU 3.4
  UBLOCK_KHAROSHTHI | Stable: ICU 3.4
  UBLOCK_MODIFIER_TONE_LETTERS | Stable: ICU 3.4
  UBLOCK_NEW_TAI_LUE | Stable: ICU 3.4
  UBLOCK_OLD_PERSIAN | Stable: ICU 3.4
  UBLOCK_PHONETIC_EXTENSIONS_SUPPLEMENT | Stable: ICU 3.4
  UBLOCK_SUPPLEMENTAL_PUNCTUATION | Stable: ICU 3.4
  UBLOCK_SYLOTI_NAGRI | Stable: ICU 3.4
  UBLOCK_TIFINAGH | Stable: ICU 3.4
  UBLOCK_VERTICAL_FORMS | Stable: ICU 3.4
  UBLOCK_NKO | Stable: ICU 3.6
  UBLOCK_BALINESE | Stable: ICU 3.6
  UBLOCK_LATIN_EXTENDED_C | Stable: ICU 3.6
  UBLOCK_LATIN_EXTENDED_D | Stable: ICU 3.6
  UBLOCK_PHAGS_PA | Stable: ICU 3.6
  UBLOCK_PHOENICIAN | Stable: ICU 3.6
  UBLOCK_CUNEIFORM | Stable: ICU 3.6
  UBLOCK_CUNEIFORM_NUMBERS_AND_PUNCTUATION | Stable: ICU 3.6
  UBLOCK_COUNTING_ROD_NUMERALS | Stable: ICU 3.6
  UBLOCK_SUNDANESE | Stable: ICU 4.0
  UBLOCK_LEPCHA | Stable: ICU 4.0
  UBLOCK_OL_CHIKI | Stable: ICU 4.0
  UBLOCK_CYRILLIC_EXTENDED_A | Stable: ICU 4.0
  UBLOCK_VAI | Stable: ICU 4.0
  UBLOCK_CYRILLIC_EXTENDED_B | Stable: ICU 4.0
  UBLOCK_SAURASHTRA | Stable: ICU 4.0
  UBLOCK_KAYAH_LI | Stable: ICU 4.0
  UBLOCK_REJANG | Stable: ICU 4.0
  UBLOCK_CHAM | Stable: ICU 4.0
  UBLOCK_ANCIENT_SYMBOLS | Stable: ICU 4.0
  UBLOCK_PHAISTOS_DISC | Stable: ICU 4.0
  UBLOCK_LYCIAN | Stable: ICU 4.0
  UBLOCK_CARIAN | Stable: ICU 4.0
  UBLOCK_LYDIAN | Stable: ICU 4.0
  UBLOCK_MAHJONG_TILES | Stable: ICU 4.0
  UBLOCK_DOMINO_TILES | Stable: ICU 4.0
  UBLOCK_SAMARITAN | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS_EXTENDED | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_TAI_THAM | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_VEDIC_EXTENSIONS | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_LISU | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_BAMUM | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_COMMON_INDIC_NUMBER_FORMS | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_DEVANAGARI_EXTENDED | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_HANGUL_JAMO_EXTENDED_A | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_JAVANESE | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_MYANMAR_EXTENDED_A | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_TAI_VIET | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_MEETEI_MAYEK | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_HANGUL_JAMO_EXTENDED_B | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_IMPERIAL_ARAMAIC | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_OLD_SOUTH_ARABIAN | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_AVESTAN | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_INSCRIPTIONAL_PARTHIAN | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_INSCRIPTIONAL_PAHLAVI | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_OLD_TURKIC | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_RUMI_NUMERAL_SYMBOLS | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_KAITHI | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_EGYPTIAN_HIEROGLYPHS | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_ENCLOSED_ALPHANUMERIC_SUPPLEMENT | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_ENCLOSED_IDEOGRAPHIC_SUPPLEMENT | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_C | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UBLOCK_COUNT | Stable: ICU 2.0
  UBLOCK_INVALID_CODE | Stable: ICU 2.0

Definition at line 807 of file uchar.h.

enum UCharCategory

Data for enumerated Unicode general category types.

See http://www.unicode.org/Public/UNIDATA/UnicodeData.html .

Stable:
  ICU 2.0

Enumerator:

  U_UNASSIGNED | See note !!. Comments of the form "Cn" are read by genpname. Non-category for unassigned and non-character code points. Stable: ICU 2.0
  U_GENERAL_OTHER_TYPES | Cn "Other, Not Assigned (no characters in [UnicodeData.txt] have this property)" (same as U_UNASSIGNED!). Stable: ICU 2.0
  U_UPPERCASE_LETTER | Lu. Stable: ICU 2.0
  U_LOWERCASE_LETTER | Ll. Stable: ICU 2.0
  U_TITLECASE_LETTER | Lt. Stable: ICU 2.0
  U_MODIFIER_LETTER | Lm. Stable: ICU 2.0
  U_OTHER_LETTER | Lo. Stable: ICU 2.0
  U_NON_SPACING_MARK | Mn. Stable: ICU 2.0
  U_ENCLOSING_MARK | Me. Stable: ICU 2.0
  U_COMBINING_SPACING_MARK | Mc. Stable: ICU 2.0
  U_DECIMAL_DIGIT_NUMBER | Nd. Stable: ICU 2.0
  U_LETTER_NUMBER | Nl. Stable: ICU 2.0
  U_OTHER_NUMBER | No. Stable: ICU 2.0
  U_SPACE_SEPARATOR | Zs. Stable: ICU 2.0
  U_LINE_SEPARATOR | Zl. Stable: ICU 2.0
  U_PARAGRAPH_SEPARATOR | Zp. Stable: ICU 2.0
  U_CONTROL_CHAR | Cc. Stable: ICU 2.0
  U_FORMAT_CHAR | Cf. Stable: ICU 2.0
  U_PRIVATE_USE_CHAR | Co. Stable: ICU 2.0
  U_SURROGATE | Cs. Stable: ICU 2.0
  U_DASH_PUNCTUATION | Pd. Stable: ICU 2.0
  U_START_PUNCTUATION | Ps. Stable: ICU 2.0
  U_END_PUNCTUATION | Pe. Stable: ICU 2.0
  U_CONNECTOR_PUNCTUATION | Pc. Stable: ICU 2.0
  U_OTHER_PUNCTUATION | Po. Stable: ICU 2.0
  U_MATH_SYMBOL | Sm. Stable: ICU 2.0
  U_CURRENCY_SYMBOL | Sc. Stable: ICU 2.0
  U_MODIFIER_SYMBOL | Sk. Stable: ICU 2.0
  U_OTHER_SYMBOL | So. Stable: ICU 2.0
  U_INITIAL_PUNCTUATION | Pi. Stable: ICU 2.0
  U_FINAL_PUNCTUATION | Pf. Stable: ICU 2.0
  U_CHAR_CATEGORY_COUNT | One higher than the last enum UCharCategory constant. Stable: ICU 2.0

Definition at line 572 of file uchar.h.

enum UCharDirection

This specifies the language directional property of a character set.

Stable:
  ICU 2.0

Enumerator:

  U_LEFT_TO_RIGHT | See note !!. Comments of the form "EN" are read by genpname. L Stable: ICU 2.0
  U_RIGHT_TO_LEFT | R. Stable: ICU 2.0
  U_EUROPEAN_NUMBER | EN. Stable: ICU 2.0
  U_EUROPEAN_NUMBER_SEPARATOR | ES. Stable: ICU 2.0
  U_EUROPEAN_NUMBER_TERMINATOR | ET. Stable: ICU 2.0
  U_ARABIC_NUMBER | AN. Stable: ICU 2.0
  U_COMMON_NUMBER_SEPARATOR | CS. Stable: ICU 2.0
  U_BLOCK_SEPARATOR | B. Stable: ICU 2.0
  U_SEGMENT_SEPARATOR | S. Stable: ICU 2.0
  U_WHITE_SPACE_NEUTRAL | WS. Stable: ICU 2.0
  U_OTHER_NEUTRAL | ON. Stable: ICU 2.0
  U_LEFT_TO_RIGHT_EMBEDDING | LRE. Stable: ICU 2.0
  U_LEFT_TO_RIGHT_OVERRIDE | LRO. Stable: ICU 2.0
  U_RIGHT_TO_LEFT_ARABIC | AL. Stable: ICU 2.0
  U_RIGHT_TO_LEFT_EMBEDDING | RLE. Stable: ICU 2.0
  U_RIGHT_TO_LEFT_OVERRIDE | RLO. Stable: ICU 2.0
  U_POP_DIRECTIONAL_FORMAT | PDF. Stable: ICU 2.0
  U_DIR_NON_SPACING_MARK | NSM. Stable: ICU 2.0
  U_BOUNDARY_NEUTRAL | BN. Stable: ICU 2.0
  U_CHAR_DIRECTION_COUNT | Stable: ICU 2.0

Definition at line 758 of file uchar.h.

enum UCharNameChoice

Selector constants for u_charName().

u_charName() returns the "modern" name of a Unicode character; or the name that was defined in Unicode version 1.0, before the Unicode standard merged with ISO-10646; or an "extended" name that gives each Unicode code point a unique name.

See also:
  u_charName

Stable:
  ICU 2.0

Enumerator:

  U_CHAR_NAME_ALIAS | Corrected name from NameAliases.txt. Draft: This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 1385 of file uchar.h.

enum UDecompositionType

Decomposition Type constants.

See also:
  UCHAR_DECOMPOSITION_TYPE

Stable:
  ICU 2.2

Definition at line 1418 of file uchar.h.

enum UEastAsianWidth

East Asian Width constants.

See also:
  UCHAR_EAST_ASIAN_WIDTH
  u_getIntPropertyValue

Stable:
  ICU 2.2

Definition at line 1360 of file uchar.h.

enum UGraphemeClusterBreak

Grapheme Cluster Break constants.

See also:
  UCHAR_GRAPHEME_CLUSTER_BREAK

Stable:
  ICU 3.4

Definition at line 1529 of file uchar.h.

enum UHangulSyllableType

Hangul Syllable Type constants.

See also:
  UCHAR_HANGUL_SYLLABLE_TYPE

Stable:
  ICU 2.6

Definition at line 1663 of file uchar.h.

enum UJoiningGroup

Joining Group constants.

See also:
  UCHAR_JOINING_GROUP

Stable:
  ICU 2.2

Enumerator:

  U_JG_FE | Stable: ICU 2.6
  U_JG_KHAPH | Stable: ICU 2.6
  U_JG_ZHAIN | Stable: ICU 2.6
  U_JG_BURUSHASKI_YEH_BARREE | Stable: ICU 4.0
  U_JG_FARSI_YEH | Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  U_JG_NYA | Draft: This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 1462 of file uchar.h.

enum UJoiningType

Joining Type constants.

See also:
  UCHAR_JOINING_TYPE

Stable:
  ICU 2.2

Definition at line 1446 of file uchar.h.

enum ULineBreak

Line Break constants.

See also:
  UCHAR_LINE_BREAK

Stable:
  ICU 2.2

Enumerator:

  U_LB_INSEPARABLE | Renamed from the misspelled "inseperable" in Unicode 4.0.1/ICU 3.0. Stable: ICU 3.0

Definition at line 1600 of file uchar.h.

enum UNumericType

Numeric Type constants.

See also:
  UCHAR_NUMERIC_TYPE

Stable:
  ICU 2.2

Definition at line 1649 of file uchar.h.

enum UProperty

Selection constants for Unicode properties.

These constants are used in functions like u_hasBinaryProperty to select one of the Unicode properties.

The properties APIs are intended to reflect Unicode properties as defined in the Unicode Character Database (UCD) and Unicode Technical Reports (UTR). For details about the properties see http://www.unicode.org/ucd/ . For names of Unicode properties see the UCD file PropertyAliases.txt.

Important: If ICU is built with UCD files from Unicode versions below, e.g., 3.2, then properties marked with "new in Unicode 3.2" are not or not fully available. Check u_getUnicodeVersion to be sure.

See also:
  u_hasBinaryProperty
  u_getIntPropertyValue
  u_getUnicodeVersion

Stable:
  ICU 2.1

Enumerator:

  UCHAR_ALPHABETIC | Binary property Alphabetic. Same as u_isUAlphabetic, different from u_isalpha. Lu+Ll+Lt+Lm+Lo+Nl+Other_Alphabetic Stable: ICU 2.1
  UCHAR_BINARY_START | First constant for binary Unicode properties. Stable: ICU 2.1
  UCHAR_ASCII_HEX_DIGIT | Binary property ASCII_Hex_Digit. 0-9 A-F a-f Stable: ICU 2.1
  UCHAR_BIDI_CONTROL | Binary property Bidi_Control. Format controls which have specific functions in the Bidi Algorithm. Stable: ICU 2.1
  UCHAR_BIDI_MIRRORED | Binary property Bidi_Mirrored. Characters that may change display in RTL text. Same as u_isMirrored. See Bidi Algorithm, UTR 9. Stable: ICU 2.1
  UCHAR_DASH | Binary property Dash. Variations of dashes. Stable: ICU 2.1
  UCHAR_DEFAULT_IGNORABLE_CODE_POINT | Binary property Default_Ignorable_Code_Point (new in Unicode 3.2). Ignorable in most processing. <2060..206F, FFF0..FFFB, E0000..E0FFF>+Other_Default_Ignorable_Code_Point+(Cf+Cc+Cs-White_Space) Stable: ICU 2.1
  UCHAR_DEPRECATED | Binary property Deprecated (new in Unicode 3.2). The usage of deprecated characters is strongly discouraged. Stable: ICU 2.1
  UCHAR_DIACRITIC | Binary property Diacritic. Characters that linguistically modify the meaning of another character to which they apply. Stable: ICU 2.1
  UCHAR_EXTENDER | Binary property Extender. Extend the value or shape of a preceding alphabetic character, e.g., length and iteration marks. Stable: ICU 2.1
  UCHAR_FULL_COMPOSITION_EXCLUSION | Binary property Full_Composition_Exclusion. CompositionExclusions.txt+Singleton Decompositions+ Non-Starter Decompositions. Stable: ICU 2.1
  UCHAR_GRAPHEME_BASE | Binary property Grapheme_Base (new in Unicode 3.2). For programmatic determination of grapheme cluster boundaries. [0..10FFFF]-Cc-Cf-Cs-Co-Cn-Zl-Zp-Grapheme_Link-Grapheme_Extend-CGJ Stable: ICU 2.1
  UCHAR_GRAPHEME_EXTEND | Binary property Grapheme_Extend (new in Unicode 3.2). For programmatic determination of grapheme cluster boundaries. Me+Mn+Mc+Other_Grapheme_Extend-Grapheme_Link-CGJ Stable: ICU 2.1
  UCHAR_GRAPHEME_LINK | Binary property Grapheme_Link (new in Unicode 3.2). For programmatic determination of grapheme cluster boundaries. Stable: ICU 2.1
  UCHAR_HEX_DIGIT | Binary property Hex_Digit. Characters commonly used for hexadecimal numbers. Stable: ICU 2.1
  UCHAR_HYPHEN | Binary property Hyphen. Dashes used to mark connections between pieces of words, plus the Katakana middle dot. Stable: ICU 2.1
  UCHAR_ID_CONTINUE | Binary property ID_Continue. Characters that can continue an identifier. DerivedCoreProperties.txt also says "NOTE: Cf characters should be filtered out." ID_Start+Mn+Mc+Nd+Pc Stable: ICU 2.1
  UCHAR_ID_START | Binary property ID_Start. Characters that can start an identifier. Lu+Ll+Lt+Lm+Lo+Nl Stable: ICU 2.1
  UCHAR_IDEOGRAPHIC | Binary property Ideographic. CJKV ideographs. Stable: ICU 2.1
  UCHAR_IDS_BINARY_OPERATOR | Binary property IDS_Binary_Operator (new in Unicode 3.2). For programmatic determination of Ideographic Description Sequences. Stable: ICU 2.1
  UCHAR_IDS_TRINARY_OPERATOR | Binary property IDS_Trinary_Operator (new in Unicode 3.2). For programmatic determination of Ideographic Description Sequences. Stable: ICU 2.1
  UCHAR_JOIN_CONTROL | Binary property Join_Control. Format controls for cursive joining and ligation. Stable: ICU 2.1
  UCHAR_LOGICAL_ORDER_EXCEPTION | Binary property Logical_Order_Exception (new in Unicode 3.2). Characters that do not use logical order and require special handling in most processing. Stable: ICU 2.1
  UCHAR_LOWERCASE | Binary property Lowercase. Same as u_isULowercase, different from u_islower. Ll+Other_Lowercase Stable: ICU 2.1
  UCHAR_MATH | Binary property Math. Sm+Other_Math Stable: ICU 2.1
  UCHAR_NONCHARACTER_CODE_POINT | Binary property Noncharacter_Code_Point. Code points that are explicitly defined as illegal for the encoding of characters. Stable: ICU 2.1
  UCHAR_QUOTATION_MARK | Binary property Quotation_Mark. Stable: ICU 2.1
  UCHAR_RADICAL | Binary property Radical (new in Unicode 3.2). For programmatic determination of Ideographic Description Sequences. Stable: ICU 2.1
  UCHAR_SOFT_DOTTED | Binary property Soft_Dotted (new in Unicode 3.2). Characters with a "soft dot", like i or j. An accent placed on these characters causes the dot to disappear. Stable: ICU 2.1
  UCHAR_TERMINAL_PUNCTUATION | Binary property Terminal_Punctuation. Punctuation characters that generally mark the end of textual units. Stable: ICU 2.1
  UCHAR_UNIFIED_IDEOGRAPH | Binary property Unified_Ideograph (new in Unicode 3.2). For programmatic determination of Ideographic Description Sequences. Stable: ICU 2.1
  UCHAR_UPPERCASE | Binary property Uppercase. Same as u_isUUppercase, different from u_isupper. Lu+Other_Uppercase Stable: ICU 2.1
  UCHAR_WHITE_SPACE | Binary property White_Space. Same as u_isUWhiteSpace, different from u_isspace and u_isWhitespace. Space characters+TAB+CR+LF-ZWSP-ZWNBSP Stable: ICU 2.1
  UCHAR_XID_CONTINUE | Binary property XID_Continue. ID_Continue modified to allow closure under normalization forms NFKC and NFKD. Stable: ICU 2.1
  UCHAR_XID_START | Binary property XID_Start. ID_Start modified to allow closure under normalization forms NFKC and NFKD. Stable: ICU 2.1
  UCHAR_CASE_SENSITIVE | Binary property Case_Sensitive. Either the source of a case mapping or _in_ the target of a case mapping. Not the same as the general category Cased_Letter. Stable: ICU 2.6
  UCHAR_S_TERM | Binary property STerm (new in Unicode 4.0.1). Sentence Terminal. Used in UAX #29: Text Boundaries (http://www.unicode.org/reports/tr29/) Stable: ICU 3.0
  UCHAR_VARIATION_SELECTOR | Binary property Variation_Selector (new in Unicode 4.0.1). Indicates all those characters that qualify as Variation Selectors. For details on the behavior of these characters, see StandardizedVariants.html and 15.6 Variation Selectors. Stable: ICU 3.0
  UCHAR_NFD_INERT | Binary property NFD_Inert. ICU-specific property for characters that are inert under NFD, i.e., they do not interact with adjacent characters. See the documentation for the Normalizer2 class and the Normalizer2::isInert() method. Stable: ICU 3.0
  UCHAR_NFKD_INERT | Binary property NFKD_Inert. ICU-specific property for characters that are inert under NFKD, i.e., they do not interact with adjacent characters. See the documentation for the Normalizer2 class and the Normalizer2::isInert() method. Stable: ICU 3.0
  UCHAR_NFC_INERT | Binary property NFC_Inert. ICU-specific property for characters that are inert under NFC, i.e., they do not interact with adjacent characters. See the documentation for the Normalizer2 class and the Normalizer2::isInert() method. Stable: ICU 3.0
  UCHAR_NFKC_INERT | Binary property NFKC_Inert. ICU-specific property for characters that are inert under NFKC, i.e., they do not interact with adjacent characters. See the documentation for the Normalizer2 class and the Normalizer2::isInert() method. Stable: ICU 3.0
  UCHAR_SEGMENT_STARTER | Binary Property Segment_Starter. ICU-specific property for characters that are starters in terms of Unicode normalization and combining character sequences. They have ccc=0 and do not occur in non-initial position of the canonical decomposition of any character (like a-umlaut in NFD and a Jamo T in an NFD(Hangul LVT)). ICU uses this property for segmenting a string for generating a set of canonically equivalent strings, e.g. for canonical closure while processing collation tailoring rules. Stable: ICU 3.0
  UCHAR_PATTERN_SYNTAX | Binary property Pattern_Syntax (new in Unicode 4.1). See UAX #31 Identifier and Pattern Syntax (http://www.unicode.org/reports/tr31/) Stable: ICU 3.4
  UCHAR_PATTERN_WHITE_SPACE | Binary property Pattern_White_Space (new in Unicode 4.1). See UAX #31 Identifier and Pattern Syntax (http://www.unicode.org/reports/tr31/) Stable: ICU 3.4
  UCHAR_POSIX_ALNUM | Binary property alnum (a C/POSIX character class). Implemented according to the UTS #18 Annex C Standard Recommendation. See the uchar.h file documentation. Stable: ICU 3.4
  UCHAR_POSIX_BLANK | Binary property blank (a C/POSIX character class). Implemented according to the UTS #18 Annex C Standard Recommendation. See the uchar.h file documentation. Stable: ICU 3.4
  UCHAR_POSIX_GRAPH | Binary property graph (a C/POSIX character class). Implemented according to the UTS #18 Annex C Standard Recommendation. See the uchar.h file documentation. Stable: ICU 3.4
  UCHAR_POSIX_PRINT | Binary property print (a C/POSIX character class). Implemented according to the UTS #18 Annex C Standard Recommendation. See the uchar.h file documentation. Stable: ICU 3.4
  UCHAR_POSIX_XDIGIT | Binary property xdigit (a C/POSIX character class). Implemented according to the UTS #18 Annex C Standard Recommendation. See the uchar.h file documentation. Stable: ICU 3.4
  UCHAR_CASED | Binary property Cased. For Lowercase, Uppercase and Titlecase characters. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CASE_IGNORABLE | Binary property Case_Ignorable. Used in context-sensitive case mappings. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CHANGES_WHEN_LOWERCASED | Binary property Changes_When_Lowercased. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CHANGES_WHEN_UPPERCASED | Binary property Changes_When_Uppercased. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CHANGES_WHEN_TITLECASED | Binary property Changes_When_Titlecased. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CHANGES_WHEN_CASEFOLDED | Binary property Changes_When_Casefolded. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CHANGES_WHEN_CASEMAPPED | Binary property Changes_When_Casemapped. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_CHANGES_WHEN_NFKC_CASEFOLDED | Binary property Changes_When_NFKC_Casefolded. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  UCHAR_BINARY_LIMIT | One more than the last constant for binary Unicode properties. Stable: ICU 2.1
  UCHAR_BIDI_CLASS | Enumerated property Bidi_Class. Same as u_charDirection, returns UCharDirection values. Stable: ICU 2.2
  UCHAR_INT_START | First constant for enumerated/integer Unicode properties. Stable: ICU 2.2
  UCHAR_BLOCK | Enumerated property Block. Same as ublock_getCode, returns UBlockCode values. Stable: ICU 2.2
  UCHAR_CANONICAL_COMBINING_CLASS | Enumerated property Canonical_Combining_Class. Same as u_getCombiningClass, returns 8-bit numeric values. Stable: ICU 2.2
  UCHAR_DECOMPOSITION_TYPE | Enumerated property Decomposition_Type. Returns UDecompositionType values. Stable: ICU 2.2
  UCHAR_EAST_ASIAN_WIDTH | Enumerated property East_Asian_Width. See http://www.unicode.org/reports/tr11/ Returns UEastAsianWidth values. Stable: ICU 2.2
  UCHAR_GENERAL_CATEGORY | Enumerated property General_Category. Same as u_charType, returns UCharCategory values. Stable: ICU 2.2
  UCHAR_JOINING_GROUP | Enumerated property Joining_Group. Returns UJoiningGroup values. Stable: ICU 2.2
  UCHAR_JOINING_TYPE | Enumerated property Joining_Type. Returns UJoiningType values. Stable: ICU 2.2
  UCHAR_LINE_BREAK | Enumerated property Line_Break. Returns ULineBreak values. Stable: ICU 2.2
  UCHAR_NUMERIC_TYPE | Enumerated property Numeric_Type. Returns UNumericType values. Stable: ICU 2.2
  UCHAR_SCRIPT | Enumerated property Script. Same as uscript_getScript, returns UScriptCode values. Stable: ICU 2.2
  UCHAR_HANGUL_SYLLABLE_TYPE | Enumerated property Hangul_Syllable_Type, new in Unicode 4. Returns UHangulSyllableType values. Stable: ICU 2.6
  UCHAR_NFD_QUICK_CHECK | Enumerated property NFD_Quick_Check. Returns UNormalizationCheckResult values. Stable: ICU 3.0
  UCHAR_NFKD_QUICK_CHECK | Enumerated property NFKD_Quick_Check. Returns UNormalizationCheckResult values. Stable: ICU 3.0
  UCHAR_NFC_QUICK_CHECK | Enumerated property NFC_Quick_Check. Returns UNormalizationCheckResult values. Stable: ICU 3.0
  UCHAR_NFKC_QUICK_CHECK | Enumerated property NFKC_Quick_Check. Returns UNormalizationCheckResult values. Stable: ICU 3.0
  UCHAR_LEAD_CANONICAL_COMBINING_CLASS | Enumerated property Lead_Canonical_Combining_Class. ICU-specific property for the ccc of the first code point of the decomposition, or lccc(c)=ccc(NFD(c)[0]). Useful for checking for canonically ordered text; see UNORM_FCD and http://www.unicode.org/notes/tn5/#FCD . Returns 8-bit numeric values like UCHAR_CANONICAL_COMBINING_CLASS. Stable: ICU 3.0
  UCHAR_TRAIL_CANONICAL_COMBINING_CLASS | Enumerated property Trail_Canonical_Combining_Class. ICU-specific property for the ccc of the last code point of the decomposition, or tccc(c)=ccc(NFD(c)[last]). Useful for checking for canonically ordered text; see UNORM_FCD and http://www.unicode.org/notes/tn5/#FCD . Returns 8-bit numeric values like UCHAR_CANONICAL_COMBINING_CLASS. Stable: ICU 3.0
  UCHAR_GRAPHEME_CLUSTER_BREAK | Enumerated property Grapheme_Cluster_Break (new in Unicode 4.1). Used in UAX #29: Text Boundaries (http://www.unicode.org/reports/tr29/) Returns UGraphemeClusterBreak values. Stable: ICU 3.4
  UCHAR_SENTENCE_BREAK | Enumerated property Sentence_Break (new in Unicode 4.1). Used in UAX #29: Text Boundaries (http://www.unicode.org/reports/tr29/) Returns USentenceBreak values. Stable: ICU 3.4
  UCHAR_WORD_BREAK | Enumerated property Word_Break (new in Unicode 4.1). Used in UAX #29: Text Boundaries (http://www.unicode.org/reports/tr29/) Returns UWordBreakValues values. Stable: ICU 3.4
  UCHAR_INT_LIMIT | One more than the last constant for enumerated/integer Unicode properties. Stable: ICU 2.2
  UCHAR_GENERAL_CATEGORY_MASK | Bitmask property General_Category_Mask. This is the General_Category property returned as a bit mask. When used in u_getIntPropertyValue(c), same as U_MASK(u_charType(c)), returns bit masks for UCharCategory values where exactly one bit is set. When used with u_getPropertyValueName() and u_getPropertyValueEnum(), a multi-bit mask is used for sets of categories like "Letters". Mask values should be cast to uint32_t. Stable: ICU 2.4
  UCHAR_MASK_START | First constant for bit-mask Unicode properties. Stable: ICU 2.4
  UCHAR_MASK_LIMIT | One more than the last constant for bit-mask Unicode properties. Stable: ICU 2.4
  UCHAR_NUMERIC_VALUE | Double property Numeric_Value. Corresponds to u_getNumericValue. Stable: ICU 2.4
  UCHAR_DOUBLE_START | First constant for double Unicode properties. Stable: ICU 2.4
  UCHAR_DOUBLE_LIMIT | One more than the last constant for double Unicode properties. Stable: ICU 2.4
  UCHAR_AGE | String property Age. Corresponds to u_charAge. Stable: ICU 2.4
  UCHAR_STRING_START | First constant for string Unicode properties. Stable: ICU 2.4
  UCHAR_BIDI_MIRRORING_GLYPH | String property Bidi_Mirroring_Glyph. Corresponds to u_charMirror. Stable: ICU 2.4
  UCHAR_CASE_FOLDING | String property Case_Folding. Corresponds to u_strFoldCase in ustring.h. Stable: ICU 2.4
  UCHAR_ISO_COMMENT | String property ISO_Comment. Corresponds to u_getISOComment. Stable: ICU 2.4
  UCHAR_LOWERCASE_MAPPING | String property Lowercase_Mapping. Corresponds to u_strToLower in ustring.h. Stable: ICU 2.4
  UCHAR_NAME | String property Name. Corresponds to u_charName. Stable: ICU 2.4
  UCHAR_SIMPLE_CASE_FOLDING | String property Simple_Case_Folding. Corresponds to u_foldCase. Stable: ICU 2.4
  UCHAR_SIMPLE_LOWERCASE_MAPPING | String property Simple_Lowercase_Mapping. Corresponds to u_tolower. Stable: ICU 2.4
  UCHAR_SIMPLE_TITLECASE_MAPPING | String property Simple_Titlecase_Mapping. Corresponds to u_totitle. Stable: ICU 2.4
  UCHAR_SIMPLE_UPPERCASE_MAPPING | String property Simple_Uppercase_Mapping. Corresponds to u_toupper. Stable: ICU 2.4
  UCHAR_TITLECASE_MAPPING | String property Titlecase_Mapping. Corresponds to u_strToTitle in ustring.h. Stable: ICU 2.4
  UCHAR_UNICODE_1_NAME | String property Unicode_1_Name. Corresponds to u_charName. Stable: ICU 2.4
  UCHAR_UPPERCASE_MAPPING | String property Uppercase_Mapping. Corresponds to u_strToUpper in ustring.h. Stable: ICU 2.4
  UCHAR_STRING_LIMIT | One more than the last constant for string Unicode properties. Stable: ICU 2.4
  UCHAR_INVALID_CODE | Represents a nonexistent or invalid property or property value. Stable: ICU 2.4

Definition at line 174 of file uchar.h.

enum UPropertyNameChoice

Selector constants for u_getPropertyName() and u_getPropertyValueName().

These selectors are used to choose which name is returned for a given property or value. All properties and values have a long name. Most have a short name, but some do not. Unicode allows for additional names, beyond the long and short name, which would be indicated by U_LONG_PROPERTY_NAME + i, where i=1, 2,...

See also:
  u_getPropertyName()
  u_getPropertyValueName()

Stable:
  ICU 2.4

Definition at line 1406 of file uchar.h.

enum USentenceBreak

Sentence Break constants.

See also:
  UCHAR_SENTENCE_BREAK

Stable:
  ICU 3.4

Definition at line 1575 of file uchar.h.

enum UWordBreakValues

Word Break constants.

(UWordBreak is a pre-existing enum type in ubrk.h for word break status tags.)

See also:
  UCHAR_WORD_BREAK

Stable:
  ICU 3.4

Definition at line 1552 of file uchar.h.

## Function Documentation

void u_charAge | ( | UChar32 | c,
|  | UVersionInfo | versionArray |
| ) |  |  |

Get the "age" of the code point.

The "age" is the Unicode version when the code point was first designated (as a non-character or for Private Use) or assigned a character. This can be useful to avoid emitting code points to receiving processes that do not accept newer characters. The data is from the UCD file DerivedAge.txt.

Parameters:

  | c | The code point.
  | versionArray | The Unicode version number array, to be filled in.

Stable:
  ICU 2.1

int32_t u_charDigitValue | ( | UChar32 | c | ) |

Returns the decimal digit value of a decimal digit character.

Such characters have the general category "Nd" (decimal digit numbers) and a Numeric_Type of Decimal.

Unlike ICU releases before 2.6, no digit values are returned for any Han characters because Han number characters are often used with a special Chinese-style number format (with characters for powers of 10 in between) instead of in decimal-positional notation. Unicode 4 explicitly assigns Han number characters the Numeric_Type Numeric instead of Decimal. See Jitterbug 1483 for more details.

Use u_getIntPropertyValue(c, UCHAR_NUMERIC_TYPE) and u_getNumericValue() for complete numeric Unicode properties.

Parameters:

  | c | the code point for which to get the decimal digit value

Returns:
  the decimal digit value of c, or -1 if c is not a decimal digit character

See also:
  u_getNumericValue

Stable:
  ICU 2.0

UCharDirection u_charDirection | ( | UChar32 | c | ) |

Returns the bidirectional category value for the code point, which is used in the Unicode bidirectional algorithm (UAX #9 http://www.unicode.org/reports/tr9/).

Note that some unassigned code points have bidi values of R or AL because they are in blocks that are reserved for Right-To-Left scripts.

Same as java.lang.Character.getDirectionality()

Parameters:

  | c | the code point to be tested

Returns:
  the bidirectional category (UCharDirection) value

See also:
  UCharDirection

Stable:
  ICU 2.0

UChar32 u_charFromName | ( | UCharNameChoice | nameChoice,
|  | const char * | name,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Find a Unicode character by its name and return its code point value.

The name is matched exactly and completely. If the name does not correspond to a code point, pErrorCode is set to `U_INVALID_CHAR_FOUND`. A Unicode 1.0 name is matched only if it differs from the modern name. Unicode names are all uppercase. Extended names are lowercase followed by an uppercase hexadecimal number, and within angle brackets.

Parameters:

  | nameChoice | Selector for which name to match.
  | name | The name to match.
  | pErrorCode | Pointer to a UErrorCode variable

Returns:
  The Unicode value of the code point with the given name, or an undefined value if there is no such code point.

See also:
  UCharNameChoice
  u_charName
  u_enumCharNames

Stable:
  ICU 1.7

UChar32 u_charMirror | ( | UChar32 | c | ) |

Maps the specified character to a "mirror-image" character.

For characters with the Bidi_Mirrored property, implementations sometimes need a "poor man's" mapping to another Unicode character (code point) such that the default glyph may serve as the mirror-image of the default glyph of the specified character. This is useful for text conversion to and from codepages with visual order, and for displays without glyph selecetion capabilities.

Parameters:

  | c | the code point to be mapped

Returns:
  another Unicode code point that may serve as a mirror-image substitute, or c itself if there is no such mapping or c does not have the Bidi_Mirrored property

See also:
  UCHAR_BIDI_MIRRORED
  u_isMirrored

Stable:
  ICU 2.0

int32_t u_charName | ( | UChar32 | code,
|  | UCharNameChoice | nameChoice,
|  | char * | buffer,
|  | int32_t | bufferLength,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Retrieve the name of a Unicode character.

Depending on `nameChoice`, the character name written into the buffer is the "modern" name or the name that was defined in Unicode version 1.0. The name contains only "invariant" characters like A-Z, 0-9, space, and '-'. Unicode 1.0 names are only retrieved if they are different from the modern names and if the data file contains the data for them. gennames may or may not be called with a command line option to include 1.0 names in unames.dat.

Parameters:

  | code | The character (code point) for which to get the name. It must be `0<=code<=0x10ffff`.
  | nameChoice | Selector for which name to get.
  | buffer | Destination address for copying the name. The name will always be zero-terminated. If there is no name, then the buffer will be set to the empty string.
  | bufferLength | `==sizeof(buffer)`
  | pErrorCode | Pointer to a UErrorCode variable; check for `U_SUCCESS()` after `u_charName()` returns.

Returns:
  The length of the name, or 0 if there is no name for this character. If the bufferLength is less than or equal to the length, then the buffer contains the truncated name and the returned length indicates the full length of the name. The length does not include the zero-termination.

See also:
  UCharNameChoice
  u_charFromName
  u_enumCharNames

Stable:
  ICU 2.0

int8_t u_charType | ( | UChar32 | c | ) |

Returns the general category value for the code point.

Same as java.lang.Character.getType().

Parameters:

  | c | the code point to be tested

Returns:
  the general category (UCharCategory) value

See also:
  UCharCategory

Stable:
  ICU 2.0

int32_t u_digit | ( | UChar32 | ch,
|  | int8_t | radix |
| ) |  |  |

Returns the decimal digit value of the code point in the specified radix.

If the radix is not in the range `2<=radix<=36` or if the value of `c` is not a valid digit in the specified radix, `-1` is returned. A character is a valid digit if at least one of the following is true:

- The character has a decimal digit value. Such characters have the general category "Nd" (decimal digit numbers) and a Numeric_Type of Decimal. In this case the value is the character's decimal digit value.
- The character is one of the uppercase Latin letters `'A'` through `'Z'`. In this case the value is `c-'A'+10`.
- The character is one of the lowercase Latin letters `'a'` through `'z'`. In this case the value is `ch-'a'+10`.
- Latin letters from both the ASCII range (0061..007A, 0041..005A) as well as from the Fullwidth ASCII range (FF41..FF5A, FF21..FF3A) are recognized.

Same as java.lang.Character.digit().

Parameters:

  | ch | the code point to be tested.
  | radix | the radix.

Returns:
  the numeric value represented by the character in the specified radix, or -1 if there is no value or if the value exceeds the radix.

See also:
  UCHAR_NUMERIC_TYPE
  u_forDigit
  u_charDigitValue
  u_isdigit

Stable:
  ICU 2.0

void u_enumCharNames | ( | UChar32 | start,
|  | UChar32 | limit,
|  | UEnumCharNamesFn * | fn,
|  | void * | context,
|  | UCharNameChoice | nameChoice,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Enumerate all assigned Unicode characters between the start and limit code points (start inclusive, limit exclusive) and call a function for each, passing the code point value and the character name.

For Unicode 1.0 names, only those are enumerated that differ from the modern names.

Parameters:

  | start | The first code point in the enumeration range.
  | limit | One more than the last code point in the enumeration range (the first one after the range).
  | fn | The function that is to be called for each character name.
  | context | An arbitrary pointer that is passed to the function.
  | nameChoice | Selector for which kind of names to enumerate.
  | pErrorCode | Pointer to a UErrorCode variable

See also:
  UCharNameChoice
  UEnumCharNamesFn
  u_charName
  u_charFromName

Stable:
  ICU 1.7

void u_enumCharTypes | ( | UCharEnumTypeRange * | enumRange,
|  | const void * | context |
| ) |  |  |

Enumerate efficiently all code points with their Unicode general categories.

This is useful for building data structures (e.g., UnicodeSet's), for enumerating all assigned code points (type!=U_UNASSIGNED), etc.

For each contiguous range of code points with a given general category ("character type"), the UCharEnumTypeRange function is called. Adjacent ranges have different types. The Unicode Standard guarantees that the numeric value of the type is 0..31.

Parameters:

  | enumRange | a pointer to a function that is called for each contiguous range of code points with the same general category
  | context | an opaque pointer that is passed on to the callback function

Stable:
  ICU 2.1

See also:
  UCharCategory
  UCharEnumTypeRange

UChar32 u_foldCase | ( | UChar32 | c,
|  | uint32_t | options |
| ) |  |  |

The given character is mapped to its case folding equivalent according to UnicodeData.txt and CaseFolding.txt; if the character has no case folding equivalent, the character itself is returned.

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class. See also the User Guide chapter on C/POSIX migration: http://icu-project.org/userguide/posix.html#case_mappings

Parameters:

  | c | the code point to be mapped
  | options | Either U_FOLD_CASE_DEFAULT or U_FOLD_CASE_EXCLUDE_SPECIAL_I

Returns:
  the Simple_Case_Folding of the code point, if any; otherwise the code point itself.

Stable:
  ICU 2.0

UChar32 u_forDigit | ( | int32_t | digit,
|  | int8_t | radix |
| ) |  |  |

Determines the character representation for a specific digit in the specified radix.

If the value of `radix` is not a valid radix, or the value of `digit` is not a valid digit in the specified radix, the null character (`U+0000`) is returned.

The `radix` argument is valid if it is greater than or equal to 2 and less than or equal to 36. The `digit` argument is valid if `0 <= digit < radix`.

If the digit is less than 10, then `'0' + digit` is returned. Otherwise, the value `'a' + digit - 10` is returned.

Same as java.lang.Character.forDigit().

Parameters:

  | digit | the number to convert to a character.
  | radix | the radix.

Returns:
  the `char` representation of the specified digit in the specified radix.

See also:
  u_digit
  u_charDigitValue
  u_isdigit

Stable:
  ICU 2.0

uint8_t u_getCombiningClass | ( | UChar32 | c | ) |

Returns the combining class of the code point as specified in UnicodeData.txt.

Parameters:

  | c | the code point of the character

Returns:
  the combining class of the character

Stable:
  ICU 2.0

int32_t u_getFC_NFKC_Closure | ( | UChar32 | c,
|  | UChar * | dest,
|  | int32_t | destCapacity,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Get the FC_NFKC_Closure property string for a character.

See Unicode Standard Annex #15 for details, search for "FC_NFKC_Closure" or for "FNC": http://www.unicode.org/reports/tr15/

Parameters:

  | c | The character (code point) for which to get the FC_NFKC_Closure string. It must be `0<=c<=0x10ffff`.
  | dest | Destination address for copying the string. The string will be zero-terminated if possible. If there is no FC_NFKC_Closure string, then the buffer will be set to the empty string.
  | destCapacity | `==sizeof(dest)`
  | pErrorCode | Pointer to a UErrorCode variable.

Returns:
  The length of the string, or 0 if there is no FC_NFKC_Closure string for this character. If the destCapacity is less than or equal to the length, then the buffer contains the truncated name and the returned length indicates the full length of the name. The length does not include the zero-termination.

Stable:
  ICU 2.2

int32_t u_getIntPropertyMaxValue | ( | UProperty | which | ) |

Get the maximum value for an enumerated/integer/binary Unicode property.

Can be used together with u_getIntPropertyMinValue to allocate arrays of UnicodeSet or similar.

Examples for min/max values (for Unicode 3.2):

- UCHAR_BIDI_CLASS: 0/18 (U_LEFT_TO_RIGHT/U_BOUNDARY_NEUTRAL)
- UCHAR_SCRIPT: 0/45 (USCRIPT_COMMON/USCRIPT_TAGBANWA)
- UCHAR_IDEOGRAPHIC: 0/1 (FALSE/TRUE)

For undefined UProperty constant values, min/max values will be 0/-1.

Parameters:

  | which | UProperty selector constant, identifies which binary property to check. Must be UCHAR_BINARY_START<=which<UCHAR_BINARY_LIMIT or UCHAR_INT_START<=which<UCHAR_INT_LIMIT.

Returns:
  Maximum value returned by u_getIntPropertyValue for a Unicode property. <=0 if the property selector is out of range.

See also:
  UProperty
  u_hasBinaryProperty
  u_getUnicodeVersion
  u_getIntPropertyMaxValue
  u_getIntPropertyValue

Stable:
  ICU 2.2

int32_t u_getIntPropertyMinValue | ( | UProperty | which | ) |

Get the minimum value for an enumerated/integer/binary Unicode property.

Can be used together with u_getIntPropertyMaxValue to allocate arrays of UnicodeSet or similar.

Parameters:

  | which | UProperty selector constant, identifies which binary property to check. Must be UCHAR_BINARY_START<=which<UCHAR_BINARY_LIMIT or UCHAR_INT_START<=which<UCHAR_INT_LIMIT.

Returns:
  Minimum value returned by u_getIntPropertyValue for a Unicode property. 0 if the property selector is out of range.

See also:
  UProperty
  u_hasBinaryProperty
  u_getUnicodeVersion
  u_getIntPropertyMaxValue
  u_getIntPropertyValue

Stable:
  ICU 2.2

int32_t u_getIntPropertyValue | ( | UChar32 | c,
|  | UProperty | which |
| ) |  |  |

Get the property value for an enumerated or integer Unicode property for a code point.

Also returns binary and mask property values.

Unicode, especially in version 3.2, defines many more properties than the original set in UnicodeData.txt.

The properties APIs are intended to reflect Unicode properties as defined in the Unicode Character Database (UCD) and Unicode Technical Reports (UTR). For details about the properties see http://www.unicode.org/ . For names of Unicode properties see the UCD file PropertyAliases.txt.

Sample usage: UEastAsianWidth ea=(UEastAsianWidth)u_getIntPropertyValue(c, UCHAR_EAST_ASIAN_WIDTH); UBool b=(UBool)u_getIntPropertyValue(c, UCHAR_IDEOGRAPHIC);

Parameters:

  | c | Code point to test.
  | which | UProperty selector constant, identifies which property to check. Must be UCHAR_BINARY_START<=which<UCHAR_BINARY_LIMIT or UCHAR_INT_START<=which<UCHAR_INT_LIMIT or UCHAR_MASK_START<=which<UCHAR_MASK_LIMIT.

Returns:
  Numeric value that is directly the property value or, for enumerated properties, corresponds to the numeric value of the enumerated constant of the respective property value enumeration type (cast to enum type if necessary). Returns 0 or 1 (for FALSE/TRUE) for binary Unicode properties. Returns a bit-mask for mask properties. Returns 0 if 'which' is out of bounds or if the Unicode version does not have data for the property at all, or not for this code point.

See also:
  UProperty
  u_hasBinaryProperty
  u_getIntPropertyMinValue
  u_getIntPropertyMaxValue
  u_getUnicodeVersion

Stable:
  ICU 2.2

int32_t u_getISOComment | ( | UChar32 | c,
|  | char * | dest,
|  | int32_t | destCapacity,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Get the ISO 10646 comment for a character.

The ISO 10646 comment is an informative field in the Unicode Character Database (UnicodeData.txt field 11) and is from the ISO 10646 names list.

Note: Unicode 5.2 removes all ISO comment data, resulting in empty strings returned for all characters.

Parameters:

  | c | The character (code point) for which to get the ISO comment. It must be `0<=c<=0x10ffff`.
  | dest | Destination address for copying the comment. The comment will be zero-terminated if possible. If there is no comment, then the buffer will be set to the empty string.
  | destCapacity | `==sizeof(dest)`
  | pErrorCode | Pointer to a UErrorCode variable; check for `U_SUCCESS()` after `u_getISOComment()` returns.

Returns:
  The length of the comment, or 0 if there is no comment for this character. If the destCapacity is less than or equal to the length, then the buffer contains the truncated name and the returned length indicates the full length of the name. The length does not include the zero-termination.

Stable:
  ICU 2.2

double u_getNumericValue | ( | UChar32 | c | ) |

Get the numeric value for a Unicode code point as defined in the Unicode Character Database.

A "double" return type is necessary because some numeric values are fractions, negative, or too large for int32_t.

For characters without any numeric values in the Unicode Character Database, this function will return U_NO_NUMERIC_VALUE.

Similar to java.lang.Character.getNumericValue(), but u_getNumericValue() also supports negative values, large values, and fractions, while Java's getNumericValue() returns values 10..35 for ASCII letters.

Parameters:

  | c | Code point to get the numeric value for.

Returns:
  Numeric value of c, or U_NO_NUMERIC_VALUE if none is defined.

See also:
  U_NO_NUMERIC_VALUE

Stable:
  ICU 2.2

UProperty u_getPropertyEnum | ( | const char * | alias | ) |

Return the UProperty enum for a given property name, as specified in the Unicode database file PropertyAliases.txt.

Short, long, and any other variants are recognized.

In addition, this function maps the synthetic names "gcm" / "General_Category_Mask" to the property UCHAR_GENERAL_CATEGORY_MASK. These names are not in PropertyAliases.txt.

Parameters:

  | alias | the property name to be matched. The name is compared using "loose matching" as described in PropertyAliases.txt.

Returns:
  a UProperty enum, or UCHAR_INVALID_CODE if the given name does not match any property.

See also:
  UProperty

Stable:
  ICU 2.4

const char* u_getPropertyName | ( | UProperty | property,
|  | UPropertyNameChoice | nameChoice |
| ) |  |  |

Return the Unicode name for a given property, as given in the Unicode database file PropertyAliases.txt.

In addition, this function maps the property UCHAR_GENERAL_CATEGORY_MASK to the synthetic names "gcm" / "General_Category_Mask". These names are not in PropertyAliases.txt.

Parameters:

  | property | UProperty selector other than UCHAR_INVALID_CODE. If out of range, NULL is returned.
  | nameChoice | selector for which name to get. If out of range, NULL is returned. All properties have a long name. Most have a short name, but some do not. Unicode allows for additional names; if present these will be returned by U_LONG_PROPERTY_NAME + i, where i=1, 2,...

Returns:
  a pointer to the name, or NULL if either the property or the nameChoice is out of range. If a given nameChoice returns NULL, then all larger values of nameChoice will return NULL, with one exception: if NULL is returned for U_SHORT_PROPERTY_NAME, then U_LONG_PROPERTY_NAME (and higher) may still return a non-NULL value. The returned pointer is valid until u_cleanup() is called.

See also:
  UProperty
  UPropertyNameChoice

Stable:
  ICU 2.4

int32_t u_getPropertyValueEnum | ( | UProperty | property,
|  | const char * | alias |
| ) |  |  |

Return the property value integer for a given value name, as specified in the Unicode database file PropertyValueAliases.txt.

Short, long, and any other variants are recognized.

Note: Some of the names in PropertyValueAliases.txt will only be recognized with UCHAR_GENERAL_CATEGORY_MASK, not UCHAR_GENERAL_CATEGORY. These include: "C" / "Other", "L" / "Letter", "LC" / "Cased_Letter", "M" / "Mark", "N" / "Number", "P" / "Punctuation", "S" / "Symbol", and "Z" / "Separator".

Parameters:

  | property | UProperty selector constant. Must be UCHAR_BINARY_START<=which<UCHAR_BINARY_LIMIT or UCHAR_INT_START<=which<UCHAR_INT_LIMIT or UCHAR_MASK_START<=which<UCHAR_MASK_LIMIT. If out of range, UCHAR_INVALID_CODE is returned.
  | alias | the value name to be matched. The name is compared using "loose matching" as described in PropertyValueAliases.txt.

Returns:
  a value integer or UCHAR_INVALID_CODE if the given name does not match any value of the given property, or if the property is invalid. Note: UCHAR_GENERAL_CATEGORY_MASK values are not values of UCharCategory, but rather mask values produced by U_GET_GC_MASK(). This allows grouped categories such as [:L:] to be represented.

See also:
  UProperty

Stable:
  ICU 2.4

const char* u_getPropertyValueName | ( | UProperty | property,
|  | int32_t | value,
|  | UPropertyNameChoice | nameChoice |
| ) |  |  |

Return the Unicode name for a given property value, as given in the Unicode database file PropertyValueAliases.txt.

Note: Some of the names in PropertyValueAliases.txt can only be retrieved using UCHAR_GENERAL_CATEGORY_MASK, not UCHAR_GENERAL_CATEGORY. These include: "C" / "Other", "L" / "Letter", "LC" / "Cased_Letter", "M" / "Mark", "N" / "Number", "P" / "Punctuation", "S" / "Symbol", and "Z" / "Separator".

Parameters:

  | property | UProperty selector constant. Must be UCHAR_BINARY_START<=which<UCHAR_BINARY_LIMIT or UCHAR_INT_START<=which<UCHAR_INT_LIMIT or UCHAR_MASK_START<=which<UCHAR_MASK_LIMIT. If out of range, NULL is returned.
  | value | selector for a value for the given property. If out of range, NULL is returned. In general, valid values range from 0 up to some maximum. There are a few exceptions: (1.) UCHAR_BLOCK values begin at the non-zero value UBLOCK_BASIC_LATIN. (2.) UCHAR_CANONICAL_COMBINING_CLASS values are not contiguous and range from 0..240. (3.) UCHAR_GENERAL_CATEGORY_MASK values are not values of UCharCategory, but rather mask values produced by U_GET_GC_MASK(). This allows grouped categories such as [:L:] to be represented. Mask values range non-contiguously from 1..U_GC_P_MASK.
  | nameChoice | selector for which name to get. If out of range, NULL is returned. All values have a long name. Most have a short name, but some do not. Unicode allows for additional names; if present these will be returned by U_LONG_PROPERTY_NAME + i, where i=1, 2,...

Returns:
  a pointer to the name, or NULL if either the property or the nameChoice is out of range. If a given nameChoice returns NULL, then all larger values of nameChoice will return NULL, with one exception: if NULL is returned for U_SHORT_PROPERTY_NAME, then U_LONG_PROPERTY_NAME (and higher) may still return a non-NULL value. The returned pointer is valid until u_cleanup() is called.

See also:
  UProperty
  UPropertyNameChoice

Stable:
  ICU 2.4

void u_getUnicodeVersion | ( | UVersionInfo | versionArray | ) |

Gets the Unicode version information.

The version array is filled in with the version information for the Unicode standard that is currently used by ICU. For example, Unicode version 3.1.1 is represented as an array with the values { 3, 1, 1, 0 }.

Parameters:

  | versionArray | an output array that will be filled in with the Unicode version number

Stable:
  ICU 2.0

UBool u_hasBinaryProperty | ( | UChar32 | c,
|  | UProperty | which |
| ) |  |  |

Check a binary Unicode property for a code point.

Unicode, especially in version 3.2, defines many more properties than the original set in UnicodeData.txt.

The properties APIs are intended to reflect Unicode properties as defined in the Unicode Character Database (UCD) and Unicode Technical Reports (UTR). For details about the properties see http://www.unicode.org/ucd/ . For names of Unicode properties see the UCD file PropertyAliases.txt.

Important: If ICU is built with UCD files from Unicode versions below 3.2, then properties marked with "new in Unicode 3.2" are not or not fully available.

Parameters:

  | c | Code point to test.
  | which | UProperty selector constant, identifies which binary property to check. Must be UCHAR_BINARY_START<=which<UCHAR_BINARY_LIMIT.

Returns:
  TRUE or FALSE according to the binary Unicode property value for c. Also FALSE if 'which' is out of bounds or if the Unicode version does not have data for the property at all, or not for this code point.

See also:
  UProperty
  u_getIntPropertyValue
  u_getUnicodeVersion

Stable:
  ICU 2.1

UBool u_isalnum | ( | UChar32 | c | ) |

Determines whether the specified code point is an alphanumeric character (letter or digit) according to Java.

True for characters with general categories "L" (letters) and "Nd" (decimal digit numbers).

Same as java.lang.Character.isLetterOrDigit().

In addition to being equivalent to a Java function, this also serves as a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is an alphanumeric character according to Character.isLetterOrDigit()

Stable:
  ICU 2.0

UBool u_isalpha | ( | UChar32 | c | ) |

Determines whether the specified code point is a letter character.

True for general categories "L" (letters).

Same as java.lang.Character.isLetter().

In addition to being equivalent to a Java function, this also serves as a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a letter character

See also:
  u_isdigit
  u_isalnum

Stable:
  ICU 2.0

UBool u_isbase | ( | UChar32 | c | ) |

Determines whether the specified code point is a base character.

True for general categories "L" (letters), "N" (numbers), "Mc" (spacing combining marks), and "Me" (enclosing marks).

Note that this is different from the Unicode definition in chapter 3.5, conformance clause D13, which defines base characters to be all characters (not Cn) that do not graphically combine with preceding characters (M) and that are neither control (Cc) or format (Cf) characters.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a base character according to this function

See also:
  u_isalpha
  u_isdigit

Stable:
  ICU 2.0

UBool u_isblank | ( | UChar32 | c | ) |

Determines whether the specified code point is a "blank" or "horizontal space", a character that visibly separates words on a line.

The following are equivalent definitions:

TRUE for Unicode White_Space characters except for "vertical space controls" where "vertical space controls" are the following characters: U+000A (LF) U+000B (VT) U+000C (FF) U+000D (CR) U+0085 (NEL) U+2028 (LS) U+2029 (PS)

same as

TRUE for U+0009 (TAB) and characters with general category "Zs" (space separators) except Zero Width Space (ZWSP, U+200B).

Note: There are several ICU whitespace functions; please see the uchar.h file documentation for a detailed comparison.

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a "blank"

Stable:
  ICU 2.6

UBool u_iscntrl | ( | UChar32 | c | ) |

Determines whether the specified code point is a control character (as defined by this function).

A control character is one of the following:

- ISO 8-bit control character (U+0000..U+001f and U+007f..U+009f)
- U_CONTROL_CHAR (Cc)
- U_FORMAT_CHAR (Cf)
- U_LINE_SEPARATOR (Zl)
- U_PARAGRAPH_SEPARATOR (Zp)

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a control character

See also:
  UCHAR_DEFAULT_IGNORABLE_CODE_POINT
  u_isprint

Stable:
  ICU 2.0

UBool u_isdefined | ( | UChar32 | c | ) |

Determines whether the specified code point is "defined", which usually means that it is assigned a character.

True for general categories other than "Cn" (other, not assigned), i.e., true for all code points mentioned in UnicodeData.txt.

Note that non-character code points (e.g., U+FDD0) are not "defined" (they are Cn), but surrogate code points are "defined" (Cs).

Same as java.lang.Character.isDefined().

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is assigned a character

See also:
  u_isdigit
  u_isalpha
  u_isalnum
  u_isupper
  u_islower
  u_istitle

Stable:
  ICU 2.0

UBool u_isdigit | ( | UChar32 | c | ) |

Determines whether the specified code point is a digit character according to Java.

True for characters with general category "Nd" (decimal digit numbers). Beginning with Unicode 4, this is the same as testing for the Numeric_Type of Decimal.

Same as java.lang.Character.isDigit().

In addition to being equivalent to a Java function, this also serves as a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a digit character according to Character.isDigit()

Stable:
  ICU 2.0

UBool u_isgraph | ( | UChar32 | c | ) |

Determines whether the specified code point is a "graphic" character (printable, excluding spaces).

TRUE for all characters except those with general categories "Cc" (control codes), "Cf" (format controls), "Cs" (surrogates), "Cn" (unassigned), and "Z" (separators).

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a "graphic" character

Stable:
  ICU 2.6

UBool u_isIDIgnorable | ( | UChar32 | c | ) |

Determines if the specified character should be regarded as an ignorable character in an identifier, according to Java.

True for characters with general category "Cf" (format controls) as well as non-whitespace ISO controls (U+0000..U+0008, U+000E..U+001B, U+007F..U+009F).

Same as java.lang.Character.isIdentifierIgnorable().

Note that Unicode just recommends to ignore Cf (format controls).

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is ignorable in identifiers according to Java

See also:
  UCHAR_DEFAULT_IGNORABLE_CODE_POINT
  u_isIDStart
  u_isIDPart

Stable:
  ICU 2.0

UBool u_isIDPart | ( | UChar32 | c | ) |

Determines if the specified character is permissible in an identifier according to Java.

True for characters with general categories "L" (letters), "Nl" (letter numbers), "Nd" (decimal digits), "Mc" and "Mn" (combining marks), "Pc" (connecting punctuation), and u_isIDIgnorable(c).

Same as java.lang.Character.isUnicodeIdentifierPart(). Almost the same as Unicode's ID_Continue (UCHAR_ID_CONTINUE) except that Unicode recommends to ignore Cf which is less than u_isIDIgnorable(c).

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point may occur in an identifier according to Java

See also:
  UCHAR_ID_CONTINUE
  u_isIDStart
  u_isIDIgnorable

Stable:
  ICU 2.0

UBool u_isIDStart | ( | UChar32 | c | ) |

Determines if the specified character is permissible as the first character in an identifier according to Unicode (The Unicode Standard, Version 3.0, chapter 5.16 Identifiers).

True for characters with general categories "L" (letters) and "Nl" (letter numbers).

Same as java.lang.Character.isUnicodeIdentifierStart(). Same as UCHAR_ID_START

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point may start an identifier

See also:
  UCHAR_ID_START
  u_isalpha
  u_isIDPart

Stable:
  ICU 2.0

UBool u_isISOControl | ( | UChar32 | c | ) |

Determines whether the specified code point is an ISO control code.

True for U+0000..U+001f and U+007f..U+009f (general category "Cc").

Same as java.lang.Character.isISOControl().

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is an ISO control code

See also:
  u_iscntrl

Stable:
  ICU 2.6

UBool u_isJavaIDPart | ( | UChar32 | c | ) |

Determines if the specified character is permissible in a Java identifier.

In addition to u_isIDPart(c), true for characters with general category "Sc" (currency symbols).

Same as java.lang.Character.isJavaIdentifierPart().

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point may occur in a Java identifier

See also:
  u_isIDIgnorable
  u_isJavaIDStart
  u_isalpha
  u_isdigit
  u_isIDPart

Stable:
  ICU 2.0

UBool u_isJavaIDStart | ( | UChar32 | c | ) |

Determines if the specified character is permissible as the first character in a Java identifier.

In addition to u_isIDStart(c), true for characters with general categories "Sc" (currency symbols) and "Pc" (connecting punctuation).

Same as java.lang.Character.isJavaIdentifierStart().

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point may start a Java identifier

See also:
  u_isJavaIDPart
  u_isalpha
  u_isIDStart

Stable:
  ICU 2.0

UBool u_isJavaSpaceChar | ( | UChar32 | c | ) |

Determine if the specified code point is a space character according to Java.

True for characters with general categories "Z" (separators), which does not include control codes (e.g., TAB or Line Feed).

Same as java.lang.Character.isSpaceChar().

Note: There are several ICU whitespace functions; please see the uchar.h file documentation for a detailed comparison.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a space character according to Character.isSpaceChar()

See also:
  u_isspace
  u_isWhitespace
  u_isUWhiteSpace

Stable:
  ICU 2.6

UBool u_islower | ( | UChar32 | c | ) |

Determines whether the specified code point has the general category "Ll" (lowercase letter).

Same as java.lang.Character.isLowerCase().

This misses some characters that are also lowercase but have a different general category value. In order to include those, use UCHAR_LOWERCASE.

In addition to being equivalent to a Java function, this also serves as a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is an Ll lowercase letter

See also:
  UCHAR_LOWERCASE
  u_isupper
  u_istitle

Stable:
  ICU 2.0

UBool u_isMirrored | ( | UChar32 | c | ) |

Determines whether the code point has the Bidi_Mirrored property.

This property is set for characters that are commonly used in Right-To-Left contexts and need to be displayed with a "mirrored" glyph.

Same as java.lang.Character.isMirrored(). Same as UCHAR_BIDI_MIRRORED

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the character has the Bidi_Mirrored property

See also:
  UCHAR_BIDI_MIRRORED

Stable:
  ICU 2.0

UBool u_isprint | ( | UChar32 | c | ) |

Determines whether the specified code point is a printable character.

True for general categories other than "C" (controls).

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a printable character

See also:
  UCHAR_DEFAULT_IGNORABLE_CODE_POINT
  u_iscntrl

Stable:
  ICU 2.0

UBool u_ispunct | ( | UChar32 | c | ) |

Determines whether the specified code point is a punctuation character.

True for characters with general categories "P" (punctuation).

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a punctuation character

Stable:
  ICU 2.6

UBool u_isspace | ( | UChar32 | c | ) |

Determines if the specified character is a space character or not.

Note: There are several ICU whitespace functions; please see the uchar.h file documentation for a detailed comparison.

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the character to be tested

Returns:
  true if the character is a space character; false otherwise.

See also:
  u_isJavaSpaceChar
  u_isWhitespace
  u_isUWhiteSpace

Stable:
  ICU 2.0

UBool u_istitle | ( | UChar32 | c | ) |

Determines whether the specified code point is a titlecase letter.

True for general category "Lt" (titlecase letter).

Same as java.lang.Character.isTitleCase().

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is an Lt titlecase letter

See also:
  u_isupper
  u_islower
  u_totitle

Stable:
  ICU 2.0

UBool u_isUAlphabetic | ( | UChar32 | c | ) |

Check if a code point has the Alphabetic Unicode property.

Same as u_hasBinaryProperty(c, UCHAR_ALPHABETIC). This is different from u_isalpha!

Parameters:

  | c | Code point to test

Returns:
  true if the code point has the Alphabetic Unicode property, false otherwise

See also:
  UCHAR_ALPHABETIC
  u_isalpha
  u_hasBinaryProperty

Stable:
  ICU 2.1

UBool u_isULowercase | ( | UChar32 | c | ) |

Check if a code point has the Lowercase Unicode property.

Same as u_hasBinaryProperty(c, UCHAR_LOWERCASE). This is different from u_islower!

Parameters:

  | c | Code point to test

Returns:
  true if the code point has the Lowercase Unicode property, false otherwise

See also:
  UCHAR_LOWERCASE
  u_islower
  u_hasBinaryProperty

Stable:
  ICU 2.1

UBool u_isupper | ( | UChar32 | c | ) |

Determines whether the specified code point has the general category "Lu" (uppercase letter).

Same as java.lang.Character.isUpperCase().

This misses some characters that are also uppercase but have a different general category value. In order to include those, use UCHAR_UPPERCASE.

In addition to being equivalent to a Java function, this also serves as a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is an Lu uppercase letter

See also:
  UCHAR_UPPERCASE
  u_islower
  u_istitle
  u_tolower

Stable:
  ICU 2.0

UBool u_isUUppercase | ( | UChar32 | c | ) |

Check if a code point has the Uppercase Unicode property.

Same as u_hasBinaryProperty(c, UCHAR_UPPERCASE). This is different from u_isupper!

Parameters:

  | c | Code point to test

Returns:
  true if the code point has the Uppercase Unicode property, false otherwise

See also:
  UCHAR_UPPERCASE
  u_isupper
  u_hasBinaryProperty

Stable:
  ICU 2.1

UBool u_isUWhiteSpace | ( | UChar32 | c | ) |

Check if a code point has the White_Space Unicode property.

Same as u_hasBinaryProperty(c, UCHAR_WHITE_SPACE). This is different from both u_isspace and u_isWhitespace!

Note: There are several ICU whitespace functions; please see the uchar.h file documentation for a detailed comparison.

Parameters:

  | c | Code point to test

Returns:
  true if the code point has the White_Space Unicode property, false otherwise.

See also:
  UCHAR_WHITE_SPACE
  u_isWhitespace
  u_isspace
  u_isJavaSpaceChar
  u_hasBinaryProperty

Stable:
  ICU 2.1

UBool u_isWhitespace | ( | UChar32 | c | ) |

Determines if the specified code point is a whitespace character according to Java/ICU.

A character is considered to be a Java whitespace character if and only if it satisfies one of the following criteria:

- It is a Unicode Separator character (categories "Z" = "Zs" or "Zl" or "Zp"), but is not also a non-breaking space (U+00A0 NBSP or U+2007 Figure Space or U+202F Narrow NBSP).
- It is U+0009 HORIZONTAL TABULATION.
- It is U+000A LINE FEED.
- It is U+000B VERTICAL TABULATION.
- It is U+000C FORM FEED.
- It is U+000D CARRIAGE RETURN.
- It is U+001C FILE SEPARATOR.
- It is U+001D GROUP SEPARATOR.
- It is U+001E RECORD SEPARATOR.
- It is U+001F UNIT SEPARATOR.

This API tries to sync with the semantics of Java's java.lang.Character.isWhitespace(), but it may not return the exact same results because of the Unicode version difference.

Note: Unicode 4.0.1 changed U+200B ZERO WIDTH SPACE from a Space Separator (Zs) to a Format Control (Cf). Since then, isWhitespace(0x200b) returns false. See http://www.unicode.org/versions/Unicode4.0.1/

Note: There are several ICU whitespace functions; please see the uchar.h file documentation for a detailed comparison.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a whitespace character according to Java/ICU

See also:
  u_isspace
  u_isJavaSpaceChar
  u_isUWhiteSpace

Stable:
  ICU 2.0

UBool u_isxdigit | ( | UChar32 | c | ) |

Determines whether the specified code point is a hexadecimal digit.

This is equivalent to u_digit(c, 16)>=0. True for characters with general category "Nd" (decimal digit numbers) as well as Latin letters a-f and A-F in both ASCII and Fullwidth ASCII. (That is, for letters with code points 0041..0046, 0061..0066, FF21..FF26, FF41..FF46.)

In order to narrow the definition of hexadecimal digits to only ASCII characters, use (c<=0x7f && u_isxdigit(c)).

This is a C/POSIX migration function. See the comments about C/POSIX character classification functions in the documentation at the top of this header file.

Parameters:

  | c | the code point to be tested

Returns:
  TRUE if the code point is a hexadecimal digit

Stable:
  ICU 2.6

UChar32 u_tolower | ( | UChar32 | c | ) |

The given character is mapped to its lowercase equivalent according to UnicodeData.txt; if the character has no lowercase equivalent, the character itself is returned.

Same as java.lang.Character.toLowerCase().

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class. See also the User Guide chapter on C/POSIX migration: http://icu-project.org/userguide/posix.html#case_mappings

Parameters:

  | c | the code point to be mapped

Returns:
  the Simple_Lowercase_Mapping of the code point, if any; otherwise the code point itself.

Stable:
  ICU 2.0

UChar32 u_totitle | ( | UChar32 | c | ) |

The given character is mapped to its titlecase equivalent according to UnicodeData.txt; if none is defined, the character itself is returned.

Same as java.lang.Character.toTitleCase().

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class. See also the User Guide chapter on C/POSIX migration: http://icu-project.org/userguide/posix.html#case_mappings

Parameters:

  | c | the code point to be mapped

Returns:
  the Simple_Titlecase_Mapping of the code point, if any; otherwise the code point itself.

Stable:
  ICU 2.0

UChar32 u_toupper | ( | UChar32 | c | ) |

The given character is mapped to its uppercase equivalent according to UnicodeData.txt; if the character has no uppercase equivalent, the character itself is returned.

Same as java.lang.Character.toUpperCase().

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class. See also the User Guide chapter on C/POSIX migration: http://icu-project.org/userguide/posix.html#case_mappings

Parameters:

  | c | the code point to be mapped

Returns:
  the Simple_Uppercase_Mapping of the code point, if any; otherwise the code point itself.

Stable:
  ICU 2.0

UBlockCode ublock_getCode | ( | UChar32 | c | ) |

Returns the Unicode allocation block that contains the character.

Parameters:

  | c | the code point to be tested

Returns:
  the block value (UBlockCode) for c

See also:
  UBlockCode

Stable:
  ICU 2.0

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Defines